"""
Type annotations for iam service type definitions.

[Open documentation](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_iam/type_defs/)

Usage::

    ```python
    from mypy_boto3_iam.type_defs import AccessDetailOutputTypeDef

    data: AccessDetailOutputTypeDef = {...}
    ```
"""
import sys
from datetime import datetime
from typing import Dict, List, Sequence

from .literals import (
    AccessAdvisorUsageGranularityTypeType,
    ContextKeyTypeEnumType,
    DeletionTaskStatusTypeType,
    EntityTypeType,
    PolicyEvaluationDecisionTypeType,
    PolicySourceTypeType,
    PolicyUsageTypeType,
    ReportStateTypeType,
    assignmentStatusTypeType,
    encodingTypeType,
    globalEndpointTokenVersionType,
    jobStatusTypeType,
    policyOwnerEntityTypeType,
    policyScopeTypeType,
    policyTypeType,
    sortKeyTypeType,
    statusTypeType,
    summaryKeyTypeType,
)

if sys.version_info >= (3, 9):
    from typing import Literal
else:
    from typing_extensions import Literal
if sys.version_info >= (3, 9):
    from typing import TypedDict
else:
    from typing_extensions import TypedDict


__all__ = (
    "AccessDetailOutputTypeDef",
    "AccessKeyLastUsedOutputTypeDef",
    "AccessKeyMetadataOutputTypeDef",
    "AccessKeyOutputTypeDef",
    "AddClientIDToOpenIDConnectProviderRequestRequestTypeDef",
    "AddRoleToInstanceProfileRequestInstanceProfileAddRoleTypeDef",
    "AddRoleToInstanceProfileRequestRequestTypeDef",
    "AddUserToGroupRequestGroupAddUserTypeDef",
    "AddUserToGroupRequestRequestTypeDef",
    "AddUserToGroupRequestUserAddGroupTypeDef",
    "AttachGroupPolicyRequestGroupAttachPolicyTypeDef",
    "AttachGroupPolicyRequestPolicyAttachGroupTypeDef",
    "AttachGroupPolicyRequestRequestTypeDef",
    "AttachRolePolicyRequestPolicyAttachRoleTypeDef",
    "AttachRolePolicyRequestRequestTypeDef",
    "AttachRolePolicyRequestRoleAttachPolicyTypeDef",
    "AttachUserPolicyRequestPolicyAttachUserTypeDef",
    "AttachUserPolicyRequestRequestTypeDef",
    "AttachUserPolicyRequestUserAttachPolicyTypeDef",
    "AttachedPermissionsBoundaryOutputTypeDef",
    "AttachedPermissionsBoundaryResponseMetadataTypeDef",
    "AttachedPolicyOutputTypeDef",
    "ChangePasswordRequestRequestTypeDef",
    "ChangePasswordRequestServiceResourceChangePasswordTypeDef",
    "ContextEntryTypeDef",
    "CreateAccessKeyRequestRequestTypeDef",
    "CreateAccountAliasRequestRequestTypeDef",
    "CreateAccountAliasRequestServiceResourceCreateAccountAliasTypeDef",
    "CreateGroupRequestGroupCreateTypeDef",
    "CreateGroupRequestRequestTypeDef",
    "CreateGroupRequestServiceResourceCreateGroupTypeDef",
    "GroupOutputTypeDef",
    "TagTypeDef",
    "CreateLoginProfileRequestLoginProfileCreateTypeDef",
    "CreateLoginProfileRequestRequestTypeDef",
    "CreateLoginProfileRequestUserCreateLoginProfileTypeDef",
    "LoginProfileOutputTypeDef",
    "TagOutputTypeDef",
    "CreatePolicyVersionRequestPolicyCreateVersionTypeDef",
    "CreatePolicyVersionRequestRequestTypeDef",
    "PolicyVersionOutputTypeDef",
    "CreateServiceLinkedRoleRequestRequestTypeDef",
    "CreateServiceSpecificCredentialRequestRequestTypeDef",
    "ServiceSpecificCredentialOutputTypeDef",
    "DeactivateMFADeviceRequestRequestTypeDef",
    "DeleteAccessKeyRequestRequestTypeDef",
    "DeleteAccountAliasRequestRequestTypeDef",
    "DeleteGroupPolicyRequestRequestTypeDef",
    "DeleteGroupRequestRequestTypeDef",
    "DeleteInstanceProfileRequestRequestTypeDef",
    "DeleteLoginProfileRequestRequestTypeDef",
    "DeleteOpenIDConnectProviderRequestRequestTypeDef",
    "DeletePolicyRequestRequestTypeDef",
    "DeletePolicyVersionRequestRequestTypeDef",
    "DeleteRolePermissionsBoundaryRequestRequestTypeDef",
    "DeleteRolePolicyRequestRequestTypeDef",
    "DeleteRoleRequestRequestTypeDef",
    "DeleteSAMLProviderRequestRequestTypeDef",
    "DeleteSSHPublicKeyRequestRequestTypeDef",
    "DeleteServerCertificateRequestRequestTypeDef",
    "DeleteServiceLinkedRoleRequestRequestTypeDef",
    "DeleteServiceLinkedRoleResponseOutputTypeDef",
    "DeleteServiceSpecificCredentialRequestRequestTypeDef",
    "DeleteSigningCertificateRequestRequestTypeDef",
    "DeleteUserPermissionsBoundaryRequestRequestTypeDef",
    "DeleteUserPolicyRequestRequestTypeDef",
    "DeleteUserRequestRequestTypeDef",
    "DeleteVirtualMFADeviceRequestRequestTypeDef",
    "RoleUsageTypeOutputTypeDef",
    "DetachGroupPolicyRequestGroupDetachPolicyTypeDef",
    "DetachGroupPolicyRequestPolicyDetachGroupTypeDef",
    "DetachGroupPolicyRequestRequestTypeDef",
    "DetachRolePolicyRequestPolicyDetachRoleTypeDef",
    "DetachRolePolicyRequestRequestTypeDef",
    "DetachRolePolicyRequestRoleDetachPolicyTypeDef",
    "DetachUserPolicyRequestPolicyDetachUserTypeDef",
    "DetachUserPolicyRequestRequestTypeDef",
    "DetachUserPolicyRequestUserDetachPolicyTypeDef",
    "EmptyResponseMetadataTypeDef",
    "EnableMFADeviceRequestMfaDeviceAssociateTypeDef",
    "EnableMFADeviceRequestRequestTypeDef",
    "EnableMFADeviceRequestUserEnableMfaTypeDef",
    "EntityInfoOutputTypeDef",
    "ErrorDetailsOutputTypeDef",
    "OrganizationsDecisionDetailOutputTypeDef",
    "PermissionsBoundaryDecisionDetailOutputTypeDef",
    "GenerateCredentialReportResponseOutputTypeDef",
    "GenerateOrganizationsAccessReportRequestRequestTypeDef",
    "GenerateOrganizationsAccessReportResponseOutputTypeDef",
    "GenerateServiceLastAccessedDetailsRequestRequestTypeDef",
    "GenerateServiceLastAccessedDetailsResponseOutputTypeDef",
    "GetAccessKeyLastUsedRequestRequestTypeDef",
    "GetAccountAuthorizationDetailsRequestGetAccountAuthorizationDetailsPaginateTypeDef",
    "GetAccountAuthorizationDetailsRequestRequestTypeDef",
    "PasswordPolicyOutputTypeDef",
    "GetAccountSummaryResponseOutputTypeDef",
    "GetContextKeysForCustomPolicyRequestRequestTypeDef",
    "GetContextKeysForPolicyResponseOutputTypeDef",
    "GetContextKeysForPrincipalPolicyRequestRequestTypeDef",
    "GetCredentialReportResponseOutputTypeDef",
    "GetGroupPolicyRequestRequestTypeDef",
    "GetGroupPolicyResponseOutputTypeDef",
    "GetGroupRequestGetGroupPaginateTypeDef",
    "GetGroupRequestRequestTypeDef",
    "WaiterConfigTypeDef",
    "GetInstanceProfileRequestRequestTypeDef",
    "GetLoginProfileRequestRequestTypeDef",
    "GetMFADeviceRequestRequestTypeDef",
    "GetMFADeviceResponseOutputTypeDef",
    "GetOpenIDConnectProviderRequestRequestTypeDef",
    "GetOrganizationsAccessReportRequestRequestTypeDef",
    "GetPolicyRequestRequestTypeDef",
    "GetPolicyVersionRequestRequestTypeDef",
    "GetRolePolicyRequestRequestTypeDef",
    "GetRolePolicyResponseOutputTypeDef",
    "GetRoleRequestRequestTypeDef",
    "GetSAMLProviderRequestRequestTypeDef",
    "GetSSHPublicKeyRequestRequestTypeDef",
    "SSHPublicKeyOutputTypeDef",
    "GetServerCertificateRequestRequestTypeDef",
    "GetServiceLastAccessedDetailsRequestRequestTypeDef",
    "GetServiceLastAccessedDetailsWithEntitiesRequestRequestTypeDef",
    "GetServiceLinkedRoleDeletionStatusRequestRequestTypeDef",
    "GetUserPolicyRequestRequestTypeDef",
    "GetUserPolicyResponseOutputTypeDef",
    "GetUserRequestRequestTypeDef",
    "PolicyDetailOutputTypeDef",
    "ListAccessKeysRequestListAccessKeysPaginateTypeDef",
    "ListAccessKeysRequestRequestTypeDef",
    "ListAccountAliasesRequestListAccountAliasesPaginateTypeDef",
    "ListAccountAliasesRequestRequestTypeDef",
    "ListAccountAliasesResponseOutputTypeDef",
    "ListAttachedGroupPoliciesRequestListAttachedGroupPoliciesPaginateTypeDef",
    "ListAttachedGroupPoliciesRequestRequestTypeDef",
    "ListAttachedRolePoliciesRequestListAttachedRolePoliciesPaginateTypeDef",
    "ListAttachedRolePoliciesRequestRequestTypeDef",
    "ListAttachedUserPoliciesRequestListAttachedUserPoliciesPaginateTypeDef",
    "ListAttachedUserPoliciesRequestRequestTypeDef",
    "ListEntitiesForPolicyRequestListEntitiesForPolicyPaginateTypeDef",
    "ListEntitiesForPolicyRequestRequestTypeDef",
    "PolicyGroupOutputTypeDef",
    "PolicyRoleOutputTypeDef",
    "PolicyUserOutputTypeDef",
    "ListGroupPoliciesRequestListGroupPoliciesPaginateTypeDef",
    "ListGroupPoliciesRequestRequestTypeDef",
    "ListGroupPoliciesResponseOutputTypeDef",
    "ListGroupsForUserRequestListGroupsForUserPaginateTypeDef",
    "ListGroupsForUserRequestRequestTypeDef",
    "ListGroupsRequestListGroupsPaginateTypeDef",
    "ListGroupsRequestRequestTypeDef",
    "ListInstanceProfileTagsRequestListInstanceProfileTagsPaginateTypeDef",
    "ListInstanceProfileTagsRequestRequestTypeDef",
    "ListInstanceProfilesForRoleRequestListInstanceProfilesForRolePaginateTypeDef",
    "ListInstanceProfilesForRoleRequestRequestTypeDef",
    "ListInstanceProfilesRequestListInstanceProfilesPaginateTypeDef",
    "ListInstanceProfilesRequestRequestTypeDef",
    "ListMFADeviceTagsRequestListMFADeviceTagsPaginateTypeDef",
    "ListMFADeviceTagsRequestRequestTypeDef",
    "ListMFADevicesRequestListMFADevicesPaginateTypeDef",
    "ListMFADevicesRequestRequestTypeDef",
    "MFADeviceOutputTypeDef",
    "ListOpenIDConnectProviderTagsRequestListOpenIDConnectProviderTagsPaginateTypeDef",
    "ListOpenIDConnectProviderTagsRequestRequestTypeDef",
    "OpenIDConnectProviderListEntryOutputTypeDef",
    "PolicyGrantingServiceAccessOutputTypeDef",
    "ListPoliciesGrantingServiceAccessRequestRequestTypeDef",
    "ListPoliciesRequestListPoliciesPaginateTypeDef",
    "ListPoliciesRequestRequestTypeDef",
    "ListPolicyTagsRequestListPolicyTagsPaginateTypeDef",
    "ListPolicyTagsRequestRequestTypeDef",
    "ListPolicyVersionsRequestListPolicyVersionsPaginateTypeDef",
    "ListPolicyVersionsRequestRequestTypeDef",
    "ListRolePoliciesRequestListRolePoliciesPaginateTypeDef",
    "ListRolePoliciesRequestRequestTypeDef",
    "ListRolePoliciesResponseOutputTypeDef",
    "ListRoleTagsRequestListRoleTagsPaginateTypeDef",
    "ListRoleTagsRequestRequestTypeDef",
    "ListRolesRequestListRolesPaginateTypeDef",
    "ListRolesRequestRequestTypeDef",
    "ListSAMLProviderTagsRequestListSAMLProviderTagsPaginateTypeDef",
    "ListSAMLProviderTagsRequestRequestTypeDef",
    "SAMLProviderListEntryOutputTypeDef",
    "ListSSHPublicKeysRequestListSSHPublicKeysPaginateTypeDef",
    "ListSSHPublicKeysRequestRequestTypeDef",
    "SSHPublicKeyMetadataOutputTypeDef",
    "ListServerCertificateTagsRequestListServerCertificateTagsPaginateTypeDef",
    "ListServerCertificateTagsRequestRequestTypeDef",
    "ListServerCertificatesRequestListServerCertificatesPaginateTypeDef",
    "ListServerCertificatesRequestRequestTypeDef",
    "ServerCertificateMetadataOutputTypeDef",
    "ListServiceSpecificCredentialsRequestRequestTypeDef",
    "ServiceSpecificCredentialMetadataOutputTypeDef",
    "ListSigningCertificatesRequestListSigningCertificatesPaginateTypeDef",
    "ListSigningCertificatesRequestRequestTypeDef",
    "SigningCertificateOutputTypeDef",
    "ListUserPoliciesRequestListUserPoliciesPaginateTypeDef",
    "ListUserPoliciesRequestRequestTypeDef",
    "ListUserPoliciesResponseOutputTypeDef",
    "ListUserTagsRequestListUserTagsPaginateTypeDef",
    "ListUserTagsRequestRequestTypeDef",
    "ListUsersRequestListUsersPaginateTypeDef",
    "ListUsersRequestRequestTypeDef",
    "ListVirtualMFADevicesRequestListVirtualMFADevicesPaginateTypeDef",
    "ListVirtualMFADevicesRequestRequestTypeDef",
    "PaginatorConfigTypeDef",
    "PositionOutputTypeDef",
    "PutGroupPolicyRequestGroupCreatePolicyTypeDef",
    "PutGroupPolicyRequestGroupPolicyPutTypeDef",
    "PutGroupPolicyRequestRequestTypeDef",
    "PutRolePermissionsBoundaryRequestRequestTypeDef",
    "PutRolePolicyRequestRequestTypeDef",
    "PutRolePolicyRequestRolePolicyPutTypeDef",
    "PutUserPermissionsBoundaryRequestRequestTypeDef",
    "PutUserPolicyRequestRequestTypeDef",
    "PutUserPolicyRequestUserCreatePolicyTypeDef",
    "PutUserPolicyRequestUserPolicyPutTypeDef",
    "RemoveClientIDFromOpenIDConnectProviderRequestRequestTypeDef",
    "RemoveRoleFromInstanceProfileRequestInstanceProfileRemoveRoleTypeDef",
    "RemoveRoleFromInstanceProfileRequestRequestTypeDef",
    "RemoveUserFromGroupRequestGroupRemoveUserTypeDef",
    "RemoveUserFromGroupRequestRequestTypeDef",
    "RemoveUserFromGroupRequestUserRemoveGroupTypeDef",
    "ResetServiceSpecificCredentialRequestRequestTypeDef",
    "ResponseMetadataTypeDef",
    "ResyncMFADeviceRequestMfaDeviceResyncTypeDef",
    "ResyncMFADeviceRequestRequestTypeDef",
    "RoleLastUsedOutputTypeDef",
    "RoleLastUsedResponseMetadataTypeDef",
    "ServerCertificateMetadataResponseMetadataTypeDef",
    "TrackedActionLastAccessedOutputTypeDef",
    "SetDefaultPolicyVersionRequestRequestTypeDef",
    "SetSecurityTokenServicePreferencesRequestRequestTypeDef",
    "UntagInstanceProfileRequestRequestTypeDef",
    "UntagMFADeviceRequestRequestTypeDef",
    "UntagOpenIDConnectProviderRequestRequestTypeDef",
    "UntagPolicyRequestRequestTypeDef",
    "UntagRoleRequestRequestTypeDef",
    "UntagSAMLProviderRequestRequestTypeDef",
    "UntagServerCertificateRequestRequestTypeDef",
    "UntagUserRequestRequestTypeDef",
    "UpdateAccessKeyRequestAccessKeyActivateTypeDef",
    "UpdateAccessKeyRequestAccessKeyDeactivateTypeDef",
    "UpdateAccessKeyRequestAccessKeyPairActivateTypeDef",
    "UpdateAccessKeyRequestAccessKeyPairDeactivateTypeDef",
    "UpdateAccessKeyRequestRequestTypeDef",
    "UpdateAccountPasswordPolicyRequestAccountPasswordPolicyUpdateTypeDef",
    "UpdateAccountPasswordPolicyRequestRequestTypeDef",
    "UpdateAccountPasswordPolicyRequestServiceResourceCreateAccountPasswordPolicyTypeDef",
    "UpdateAssumeRolePolicyRequestAssumeRolePolicyUpdateTypeDef",
    "UpdateAssumeRolePolicyRequestRequestTypeDef",
    "UpdateGroupRequestGroupUpdateTypeDef",
    "UpdateGroupRequestRequestTypeDef",
    "UpdateLoginProfileRequestLoginProfileUpdateTypeDef",
    "UpdateLoginProfileRequestRequestTypeDef",
    "UpdateOpenIDConnectProviderThumbprintRequestRequestTypeDef",
    "UpdateRoleDescriptionRequestRequestTypeDef",
    "UpdateRoleRequestRequestTypeDef",
    "UpdateSAMLProviderRequestRequestTypeDef",
    "UpdateSAMLProviderRequestSamlProviderUpdateTypeDef",
    "UpdateSAMLProviderResponseOutputTypeDef",
    "UpdateSSHPublicKeyRequestRequestTypeDef",
    "UpdateServerCertificateRequestRequestTypeDef",
    "UpdateServerCertificateRequestServerCertificateUpdateTypeDef",
    "UpdateServiceSpecificCredentialRequestRequestTypeDef",
    "UpdateSigningCertificateRequestRequestTypeDef",
    "UpdateSigningCertificateRequestSigningCertificateActivateTypeDef",
    "UpdateSigningCertificateRequestSigningCertificateDeactivateTypeDef",
    "UpdateUserRequestRequestTypeDef",
    "UpdateUserRequestUserUpdateTypeDef",
    "UploadSSHPublicKeyRequestRequestTypeDef",
    "UploadSigningCertificateRequestRequestTypeDef",
    "UploadSigningCertificateRequestServiceResourceCreateSigningCertificateTypeDef",
    "GetAccessKeyLastUsedResponseOutputTypeDef",
    "ListAccessKeysResponseOutputTypeDef",
    "CreateAccessKeyResponseOutputTypeDef",
    "ListAttachedGroupPoliciesResponseOutputTypeDef",
    "ListAttachedRolePoliciesResponseOutputTypeDef",
    "ListAttachedUserPoliciesResponseOutputTypeDef",
    "SimulateCustomPolicyRequestRequestTypeDef",
    "SimulateCustomPolicyRequestSimulateCustomPolicyPaginateTypeDef",
    "SimulatePrincipalPolicyRequestRequestTypeDef",
    "SimulatePrincipalPolicyRequestSimulatePrincipalPolicyPaginateTypeDef",
    "CreateGroupResponseOutputTypeDef",
    "ListGroupsForUserResponseOutputTypeDef",
    "ListGroupsResponseOutputTypeDef",
    "CreateInstanceProfileRequestRequestTypeDef",
    "CreateInstanceProfileRequestServiceResourceCreateInstanceProfileTypeDef",
    "CreateOpenIDConnectProviderRequestRequestTypeDef",
    "CreatePolicyRequestRequestTypeDef",
    "CreatePolicyRequestServiceResourceCreatePolicyTypeDef",
    "CreateRoleRequestRequestTypeDef",
    "CreateRoleRequestServiceResourceCreateRoleTypeDef",
    "CreateSAMLProviderRequestRequestTypeDef",
    "CreateSAMLProviderRequestServiceResourceCreateSamlProviderTypeDef",
    "CreateUserRequestRequestTypeDef",
    "CreateUserRequestServiceResourceCreateUserTypeDef",
    "CreateUserRequestUserCreateTypeDef",
    "CreateVirtualMFADeviceRequestRequestTypeDef",
    "CreateVirtualMFADeviceRequestServiceResourceCreateVirtualMfaDeviceTypeDef",
    "TagInstanceProfileRequestRequestTypeDef",
    "TagMFADeviceRequestRequestTypeDef",
    "TagOpenIDConnectProviderRequestRequestTypeDef",
    "TagPolicyRequestRequestTypeDef",
    "TagRoleRequestRequestTypeDef",
    "TagSAMLProviderRequestRequestTypeDef",
    "TagServerCertificateRequestRequestTypeDef",
    "TagUserRequestRequestTypeDef",
    "UploadServerCertificateRequestRequestTypeDef",
    "UploadServerCertificateRequestServiceResourceCreateServerCertificateTypeDef",
    "CreateLoginProfileResponseOutputTypeDef",
    "GetLoginProfileResponseOutputTypeDef",
    "CreateOpenIDConnectProviderResponseOutputTypeDef",
    "CreateSAMLProviderResponseOutputTypeDef",
    "GetOpenIDConnectProviderResponseOutputTypeDef",
    "GetSAMLProviderResponseOutputTypeDef",
    "ListInstanceProfileTagsResponseOutputTypeDef",
    "ListMFADeviceTagsResponseOutputTypeDef",
    "ListOpenIDConnectProviderTagsResponseOutputTypeDef",
    "ListPolicyTagsResponseOutputTypeDef",
    "ListRoleTagsResponseOutputTypeDef",
    "ListSAMLProviderTagsResponseOutputTypeDef",
    "ListServerCertificateTagsResponseOutputTypeDef",
    "ListUserTagsResponseOutputTypeDef",
    "PolicyOutputTypeDef",
    "UserOutputTypeDef",
    "UserResponseMetadataTypeDef",
    "CreatePolicyVersionResponseOutputTypeDef",
    "GetPolicyVersionResponseOutputTypeDef",
    "ListPolicyVersionsResponseOutputTypeDef",
    "ManagedPolicyDetailOutputTypeDef",
    "CreateServiceSpecificCredentialResponseOutputTypeDef",
    "ResetServiceSpecificCredentialResponseOutputTypeDef",
    "DeletionTaskFailureReasonTypeOutputTypeDef",
    "EntityDetailsOutputTypeDef",
    "GetOrganizationsAccessReportResponseOutputTypeDef",
    "GetAccountPasswordPolicyResponseOutputTypeDef",
    "GetInstanceProfileRequestInstanceProfileExistsWaitTypeDef",
    "GetPolicyRequestPolicyExistsWaitTypeDef",
    "GetRoleRequestRoleExistsWaitTypeDef",
    "GetUserRequestUserExistsWaitTypeDef",
    "GetSSHPublicKeyResponseOutputTypeDef",
    "UploadSSHPublicKeyResponseOutputTypeDef",
    "GroupDetailOutputTypeDef",
    "UserDetailOutputTypeDef",
    "ListEntitiesForPolicyResponseOutputTypeDef",
    "ListMFADevicesResponseOutputTypeDef",
    "ListOpenIDConnectProvidersResponseOutputTypeDef",
    "ListPoliciesGrantingServiceAccessEntryOutputTypeDef",
    "ListSAMLProvidersResponseOutputTypeDef",
    "ListSSHPublicKeysResponseOutputTypeDef",
    "ListServerCertificatesResponseOutputTypeDef",
    "ServerCertificateOutputTypeDef",
    "UploadServerCertificateResponseOutputTypeDef",
    "ListServiceSpecificCredentialsResponseOutputTypeDef",
    "ListSigningCertificatesResponseOutputTypeDef",
    "UploadSigningCertificateResponseOutputTypeDef",
    "StatementOutputTypeDef",
    "RoleOutputTypeDef",
    "ServiceLastAccessedOutputTypeDef",
    "CreatePolicyResponseOutputTypeDef",
    "GetPolicyResponseOutputTypeDef",
    "ListPoliciesResponseOutputTypeDef",
    "CreateUserResponseOutputTypeDef",
    "GetGroupResponseOutputTypeDef",
    "GetUserResponseOutputTypeDef",
    "ListUsersResponseOutputTypeDef",
    "VirtualMFADeviceOutputTypeDef",
    "GetServiceLinkedRoleDeletionStatusResponseOutputTypeDef",
    "GetServiceLastAccessedDetailsWithEntitiesResponseOutputTypeDef",
    "ListPoliciesGrantingServiceAccessResponseOutputTypeDef",
    "GetServerCertificateResponseOutputTypeDef",
    "ResourceSpecificResultOutputTypeDef",
    "CreateRoleResponseOutputTypeDef",
    "CreateServiceLinkedRoleResponseOutputTypeDef",
    "GetRoleResponseOutputTypeDef",
    "InstanceProfileOutputTypeDef",
    "ListRolesResponseOutputTypeDef",
    "UpdateRoleDescriptionResponseOutputTypeDef",
    "GetServiceLastAccessedDetailsResponseOutputTypeDef",
    "CreateVirtualMFADeviceResponseOutputTypeDef",
    "ListVirtualMFADevicesResponseOutputTypeDef",
    "EvaluationResultOutputTypeDef",
    "CreateInstanceProfileResponseOutputTypeDef",
    "GetInstanceProfileResponseOutputTypeDef",
    "ListInstanceProfilesForRoleResponseOutputTypeDef",
    "ListInstanceProfilesResponseOutputTypeDef",
    "RoleDetailOutputTypeDef",
    "SimulatePolicyResponseOutputTypeDef",
    "GetAccountAuthorizationDetailsResponseOutputTypeDef",
)

AccessDetailOutputTypeDef = TypedDict(
    "AccessDetailOutputTypeDef",
    {
        "ServiceName": str,
        "ServiceNamespace": str,
        "Region": str,
        "EntityPath": str,
        "LastAuthenticatedTime": datetime,
        "TotalAuthenticatedEntities": int,
    },
)

AccessKeyLastUsedOutputTypeDef = TypedDict(
    "AccessKeyLastUsedOutputTypeDef",
    {
        "LastUsedDate": datetime,
        "ServiceName": str,
        "Region": str,
    },
)

AccessKeyMetadataOutputTypeDef = TypedDict(
    "AccessKeyMetadataOutputTypeDef",
    {
        "UserName": str,
        "AccessKeyId": str,
        "Status": statusTypeType,
        "CreateDate": datetime,
    },
)

AccessKeyOutputTypeDef = TypedDict(
    "AccessKeyOutputTypeDef",
    {
        "UserName": str,
        "AccessKeyId": str,
        "Status": statusTypeType,
        "SecretAccessKey": str,
        "CreateDate": datetime,
    },
)

AddClientIDToOpenIDConnectProviderRequestRequestTypeDef = TypedDict(
    "AddClientIDToOpenIDConnectProviderRequestRequestTypeDef",
    {
        "OpenIDConnectProviderArn": str,
        "ClientID": str,
    },
)

AddRoleToInstanceProfileRequestInstanceProfileAddRoleTypeDef = TypedDict(
    "AddRoleToInstanceProfileRequestInstanceProfileAddRoleTypeDef",
    {
        "RoleName": str,
    },
)

AddRoleToInstanceProfileRequestRequestTypeDef = TypedDict(
    "AddRoleToInstanceProfileRequestRequestTypeDef",
    {
        "InstanceProfileName": str,
        "RoleName": str,
    },
)

AddUserToGroupRequestGroupAddUserTypeDef = TypedDict(
    "AddUserToGroupRequestGroupAddUserTypeDef",
    {
        "UserName": str,
    },
)

AddUserToGroupRequestRequestTypeDef = TypedDict(
    "AddUserToGroupRequestRequestTypeDef",
    {
        "GroupName": str,
        "UserName": str,
    },
)

AddUserToGroupRequestUserAddGroupTypeDef = TypedDict(
    "AddUserToGroupRequestUserAddGroupTypeDef",
    {
        "GroupName": str,
    },
)

AttachGroupPolicyRequestGroupAttachPolicyTypeDef = TypedDict(
    "AttachGroupPolicyRequestGroupAttachPolicyTypeDef",
    {
        "PolicyArn": str,
    },
)

AttachGroupPolicyRequestPolicyAttachGroupTypeDef = TypedDict(
    "AttachGroupPolicyRequestPolicyAttachGroupTypeDef",
    {
        "GroupName": str,
    },
)

AttachGroupPolicyRequestRequestTypeDef = TypedDict(
    "AttachGroupPolicyRequestRequestTypeDef",
    {
        "GroupName": str,
        "PolicyArn": str,
    },
)

AttachRolePolicyRequestPolicyAttachRoleTypeDef = TypedDict(
    "AttachRolePolicyRequestPolicyAttachRoleTypeDef",
    {
        "RoleName": str,
    },
)

AttachRolePolicyRequestRequestTypeDef = TypedDict(
    "AttachRolePolicyRequestRequestTypeDef",
    {
        "RoleName": str,
        "PolicyArn": str,
    },
)

AttachRolePolicyRequestRoleAttachPolicyTypeDef = TypedDict(
    "AttachRolePolicyRequestRoleAttachPolicyTypeDef",
    {
        "PolicyArn": str,
    },
)

AttachUserPolicyRequestPolicyAttachUserTypeDef = TypedDict(
    "AttachUserPolicyRequestPolicyAttachUserTypeDef",
    {
        "UserName": str,
    },
)

AttachUserPolicyRequestRequestTypeDef = TypedDict(
    "AttachUserPolicyRequestRequestTypeDef",
    {
        "UserName": str,
        "PolicyArn": str,
    },
)

AttachUserPolicyRequestUserAttachPolicyTypeDef = TypedDict(
    "AttachUserPolicyRequestUserAttachPolicyTypeDef",
    {
        "PolicyArn": str,
    },
)

AttachedPermissionsBoundaryOutputTypeDef = TypedDict(
    "AttachedPermissionsBoundaryOutputTypeDef",
    {
        "PermissionsBoundaryType": Literal["PermissionsBoundaryPolicy"],
        "PermissionsBoundaryArn": str,
    },
)

AttachedPermissionsBoundaryResponseMetadataTypeDef = TypedDict(
    "AttachedPermissionsBoundaryResponseMetadataTypeDef",
    {
        "PermissionsBoundaryType": Literal["PermissionsBoundaryPolicy"],
        "PermissionsBoundaryArn": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AttachedPolicyOutputTypeDef = TypedDict(
    "AttachedPolicyOutputTypeDef",
    {
        "PolicyName": str,
        "PolicyArn": str,
    },
)

ChangePasswordRequestRequestTypeDef = TypedDict(
    "ChangePasswordRequestRequestTypeDef",
    {
        "OldPassword": str,
        "NewPassword": str,
    },
)

ChangePasswordRequestServiceResourceChangePasswordTypeDef = TypedDict(
    "ChangePasswordRequestServiceResourceChangePasswordTypeDef",
    {
        "OldPassword": str,
        "NewPassword": str,
    },
)

ContextEntryTypeDef = TypedDict(
    "ContextEntryTypeDef",
    {
        "ContextKeyName": str,
        "ContextKeyValues": Sequence[str],
        "ContextKeyType": ContextKeyTypeEnumType,
    },
    total=False,
)

CreateAccessKeyRequestRequestTypeDef = TypedDict(
    "CreateAccessKeyRequestRequestTypeDef",
    {
        "UserName": str,
    },
    total=False,
)

CreateAccountAliasRequestRequestTypeDef = TypedDict(
    "CreateAccountAliasRequestRequestTypeDef",
    {
        "AccountAlias": str,
    },
)

CreateAccountAliasRequestServiceResourceCreateAccountAliasTypeDef = TypedDict(
    "CreateAccountAliasRequestServiceResourceCreateAccountAliasTypeDef",
    {
        "AccountAlias": str,
    },
)

CreateGroupRequestGroupCreateTypeDef = TypedDict(
    "CreateGroupRequestGroupCreateTypeDef",
    {
        "Path": str,
    },
    total=False,
)

_RequiredCreateGroupRequestRequestTypeDef = TypedDict(
    "_RequiredCreateGroupRequestRequestTypeDef",
    {
        "GroupName": str,
    },
)
_OptionalCreateGroupRequestRequestTypeDef = TypedDict(
    "_OptionalCreateGroupRequestRequestTypeDef",
    {
        "Path": str,
    },
    total=False,
)


class CreateGroupRequestRequestTypeDef(
    _RequiredCreateGroupRequestRequestTypeDef, _OptionalCreateGroupRequestRequestTypeDef
):
    pass


_RequiredCreateGroupRequestServiceResourceCreateGroupTypeDef = TypedDict(
    "_RequiredCreateGroupRequestServiceResourceCreateGroupTypeDef",
    {
        "GroupName": str,
    },
)
_OptionalCreateGroupRequestServiceResourceCreateGroupTypeDef = TypedDict(
    "_OptionalCreateGroupRequestServiceResourceCreateGroupTypeDef",
    {
        "Path": str,
    },
    total=False,
)


class CreateGroupRequestServiceResourceCreateGroupTypeDef(
    _RequiredCreateGroupRequestServiceResourceCreateGroupTypeDef,
    _OptionalCreateGroupRequestServiceResourceCreateGroupTypeDef,
):
    pass


GroupOutputTypeDef = TypedDict(
    "GroupOutputTypeDef",
    {
        "Path": str,
        "GroupName": str,
        "GroupId": str,
        "Arn": str,
        "CreateDate": datetime,
    },
)

TagTypeDef = TypedDict(
    "TagTypeDef",
    {
        "Key": str,
        "Value": str,
    },
)

_RequiredCreateLoginProfileRequestLoginProfileCreateTypeDef = TypedDict(
    "_RequiredCreateLoginProfileRequestLoginProfileCreateTypeDef",
    {
        "Password": str,
    },
)
_OptionalCreateLoginProfileRequestLoginProfileCreateTypeDef = TypedDict(
    "_OptionalCreateLoginProfileRequestLoginProfileCreateTypeDef",
    {
        "PasswordResetRequired": bool,
    },
    total=False,
)


class CreateLoginProfileRequestLoginProfileCreateTypeDef(
    _RequiredCreateLoginProfileRequestLoginProfileCreateTypeDef,
    _OptionalCreateLoginProfileRequestLoginProfileCreateTypeDef,
):
    pass


_RequiredCreateLoginProfileRequestRequestTypeDef = TypedDict(
    "_RequiredCreateLoginProfileRequestRequestTypeDef",
    {
        "UserName": str,
        "Password": str,
    },
)
_OptionalCreateLoginProfileRequestRequestTypeDef = TypedDict(
    "_OptionalCreateLoginProfileRequestRequestTypeDef",
    {
        "PasswordResetRequired": bool,
    },
    total=False,
)


class CreateLoginProfileRequestRequestTypeDef(
    _RequiredCreateLoginProfileRequestRequestTypeDef,
    _OptionalCreateLoginProfileRequestRequestTypeDef,
):
    pass


_RequiredCreateLoginProfileRequestUserCreateLoginProfileTypeDef = TypedDict(
    "_RequiredCreateLoginProfileRequestUserCreateLoginProfileTypeDef",
    {
        "Password": str,
    },
)
_OptionalCreateLoginProfileRequestUserCreateLoginProfileTypeDef = TypedDict(
    "_OptionalCreateLoginProfileRequestUserCreateLoginProfileTypeDef",
    {
        "PasswordResetRequired": bool,
    },
    total=False,
)


class CreateLoginProfileRequestUserCreateLoginProfileTypeDef(
    _RequiredCreateLoginProfileRequestUserCreateLoginProfileTypeDef,
    _OptionalCreateLoginProfileRequestUserCreateLoginProfileTypeDef,
):
    pass


LoginProfileOutputTypeDef = TypedDict(
    "LoginProfileOutputTypeDef",
    {
        "UserName": str,
        "CreateDate": datetime,
        "PasswordResetRequired": bool,
    },
)

TagOutputTypeDef = TypedDict(
    "TagOutputTypeDef",
    {
        "Key": str,
        "Value": str,
    },
)

_RequiredCreatePolicyVersionRequestPolicyCreateVersionTypeDef = TypedDict(
    "_RequiredCreatePolicyVersionRequestPolicyCreateVersionTypeDef",
    {
        "PolicyDocument": str,
    },
)
_OptionalCreatePolicyVersionRequestPolicyCreateVersionTypeDef = TypedDict(
    "_OptionalCreatePolicyVersionRequestPolicyCreateVersionTypeDef",
    {
        "SetAsDefault": bool,
    },
    total=False,
)


class CreatePolicyVersionRequestPolicyCreateVersionTypeDef(
    _RequiredCreatePolicyVersionRequestPolicyCreateVersionTypeDef,
    _OptionalCreatePolicyVersionRequestPolicyCreateVersionTypeDef,
):
    pass


_RequiredCreatePolicyVersionRequestRequestTypeDef = TypedDict(
    "_RequiredCreatePolicyVersionRequestRequestTypeDef",
    {
        "PolicyArn": str,
        "PolicyDocument": str,
    },
)
_OptionalCreatePolicyVersionRequestRequestTypeDef = TypedDict(
    "_OptionalCreatePolicyVersionRequestRequestTypeDef",
    {
        "SetAsDefault": bool,
    },
    total=False,
)


class CreatePolicyVersionRequestRequestTypeDef(
    _RequiredCreatePolicyVersionRequestRequestTypeDef,
    _OptionalCreatePolicyVersionRequestRequestTypeDef,
):
    pass


PolicyVersionOutputTypeDef = TypedDict(
    "PolicyVersionOutputTypeDef",
    {
        "Document": str,
        "VersionId": str,
        "IsDefaultVersion": bool,
        "CreateDate": datetime,
    },
)

_RequiredCreateServiceLinkedRoleRequestRequestTypeDef = TypedDict(
    "_RequiredCreateServiceLinkedRoleRequestRequestTypeDef",
    {
        "AWSServiceName": str,
    },
)
_OptionalCreateServiceLinkedRoleRequestRequestTypeDef = TypedDict(
    "_OptionalCreateServiceLinkedRoleRequestRequestTypeDef",
    {
        "Description": str,
        "CustomSuffix": str,
    },
    total=False,
)


class CreateServiceLinkedRoleRequestRequestTypeDef(
    _RequiredCreateServiceLinkedRoleRequestRequestTypeDef,
    _OptionalCreateServiceLinkedRoleRequestRequestTypeDef,
):
    pass


CreateServiceSpecificCredentialRequestRequestTypeDef = TypedDict(
    "CreateServiceSpecificCredentialRequestRequestTypeDef",
    {
        "UserName": str,
        "ServiceName": str,
    },
)

ServiceSpecificCredentialOutputTypeDef = TypedDict(
    "ServiceSpecificCredentialOutputTypeDef",
    {
        "CreateDate": datetime,
        "ServiceName": str,
        "ServiceUserName": str,
        "ServicePassword": str,
        "ServiceSpecificCredentialId": str,
        "UserName": str,
        "Status": statusTypeType,
    },
)

DeactivateMFADeviceRequestRequestTypeDef = TypedDict(
    "DeactivateMFADeviceRequestRequestTypeDef",
    {
        "UserName": str,
        "SerialNumber": str,
    },
)

_RequiredDeleteAccessKeyRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteAccessKeyRequestRequestTypeDef",
    {
        "AccessKeyId": str,
    },
)
_OptionalDeleteAccessKeyRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteAccessKeyRequestRequestTypeDef",
    {
        "UserName": str,
    },
    total=False,
)


class DeleteAccessKeyRequestRequestTypeDef(
    _RequiredDeleteAccessKeyRequestRequestTypeDef, _OptionalDeleteAccessKeyRequestRequestTypeDef
):
    pass


DeleteAccountAliasRequestRequestTypeDef = TypedDict(
    "DeleteAccountAliasRequestRequestTypeDef",
    {
        "AccountAlias": str,
    },
)

DeleteGroupPolicyRequestRequestTypeDef = TypedDict(
    "DeleteGroupPolicyRequestRequestTypeDef",
    {
        "GroupName": str,
        "PolicyName": str,
    },
)

DeleteGroupRequestRequestTypeDef = TypedDict(
    "DeleteGroupRequestRequestTypeDef",
    {
        "GroupName": str,
    },
)

DeleteInstanceProfileRequestRequestTypeDef = TypedDict(
    "DeleteInstanceProfileRequestRequestTypeDef",
    {
        "InstanceProfileName": str,
    },
)

DeleteLoginProfileRequestRequestTypeDef = TypedDict(
    "DeleteLoginProfileRequestRequestTypeDef",
    {
        "UserName": str,
    },
)

DeleteOpenIDConnectProviderRequestRequestTypeDef = TypedDict(
    "DeleteOpenIDConnectProviderRequestRequestTypeDef",
    {
        "OpenIDConnectProviderArn": str,
    },
)

DeletePolicyRequestRequestTypeDef = TypedDict(
    "DeletePolicyRequestRequestTypeDef",
    {
        "PolicyArn": str,
    },
)

DeletePolicyVersionRequestRequestTypeDef = TypedDict(
    "DeletePolicyVersionRequestRequestTypeDef",
    {
        "PolicyArn": str,
        "VersionId": str,
    },
)

DeleteRolePermissionsBoundaryRequestRequestTypeDef = TypedDict(
    "DeleteRolePermissionsBoundaryRequestRequestTypeDef",
    {
        "RoleName": str,
    },
)

DeleteRolePolicyRequestRequestTypeDef = TypedDict(
    "DeleteRolePolicyRequestRequestTypeDef",
    {
        "RoleName": str,
        "PolicyName": str,
    },
)

DeleteRoleRequestRequestTypeDef = TypedDict(
    "DeleteRoleRequestRequestTypeDef",
    {
        "RoleName": str,
    },
)

DeleteSAMLProviderRequestRequestTypeDef = TypedDict(
    "DeleteSAMLProviderRequestRequestTypeDef",
    {
        "SAMLProviderArn": str,
    },
)

DeleteSSHPublicKeyRequestRequestTypeDef = TypedDict(
    "DeleteSSHPublicKeyRequestRequestTypeDef",
    {
        "UserName": str,
        "SSHPublicKeyId": str,
    },
)

DeleteServerCertificateRequestRequestTypeDef = TypedDict(
    "DeleteServerCertificateRequestRequestTypeDef",
    {
        "ServerCertificateName": str,
    },
)

DeleteServiceLinkedRoleRequestRequestTypeDef = TypedDict(
    "DeleteServiceLinkedRoleRequestRequestTypeDef",
    {
        "RoleName": str,
    },
)

DeleteServiceLinkedRoleResponseOutputTypeDef = TypedDict(
    "DeleteServiceLinkedRoleResponseOutputTypeDef",
    {
        "DeletionTaskId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredDeleteServiceSpecificCredentialRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteServiceSpecificCredentialRequestRequestTypeDef",
    {
        "ServiceSpecificCredentialId": str,
    },
)
_OptionalDeleteServiceSpecificCredentialRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteServiceSpecificCredentialRequestRequestTypeDef",
    {
        "UserName": str,
    },
    total=False,
)


class DeleteServiceSpecificCredentialRequestRequestTypeDef(
    _RequiredDeleteServiceSpecificCredentialRequestRequestTypeDef,
    _OptionalDeleteServiceSpecificCredentialRequestRequestTypeDef,
):
    pass


_RequiredDeleteSigningCertificateRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteSigningCertificateRequestRequestTypeDef",
    {
        "CertificateId": str,
    },
)
_OptionalDeleteSigningCertificateRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteSigningCertificateRequestRequestTypeDef",
    {
        "UserName": str,
    },
    total=False,
)


class DeleteSigningCertificateRequestRequestTypeDef(
    _RequiredDeleteSigningCertificateRequestRequestTypeDef,
    _OptionalDeleteSigningCertificateRequestRequestTypeDef,
):
    pass


DeleteUserPermissionsBoundaryRequestRequestTypeDef = TypedDict(
    "DeleteUserPermissionsBoundaryRequestRequestTypeDef",
    {
        "UserName": str,
    },
)

DeleteUserPolicyRequestRequestTypeDef = TypedDict(
    "DeleteUserPolicyRequestRequestTypeDef",
    {
        "UserName": str,
        "PolicyName": str,
    },
)

DeleteUserRequestRequestTypeDef = TypedDict(
    "DeleteUserRequestRequestTypeDef",
    {
        "UserName": str,
    },
)

DeleteVirtualMFADeviceRequestRequestTypeDef = TypedDict(
    "DeleteVirtualMFADeviceRequestRequestTypeDef",
    {
        "SerialNumber": str,
    },
)

RoleUsageTypeOutputTypeDef = TypedDict(
    "RoleUsageTypeOutputTypeDef",
    {
        "Region": str,
        "Resources": List[str],
    },
)

DetachGroupPolicyRequestGroupDetachPolicyTypeDef = TypedDict(
    "DetachGroupPolicyRequestGroupDetachPolicyTypeDef",
    {
        "PolicyArn": str,
    },
)

DetachGroupPolicyRequestPolicyDetachGroupTypeDef = TypedDict(
    "DetachGroupPolicyRequestPolicyDetachGroupTypeDef",
    {
        "GroupName": str,
    },
)

DetachGroupPolicyRequestRequestTypeDef = TypedDict(
    "DetachGroupPolicyRequestRequestTypeDef",
    {
        "GroupName": str,
        "PolicyArn": str,
    },
)

DetachRolePolicyRequestPolicyDetachRoleTypeDef = TypedDict(
    "DetachRolePolicyRequestPolicyDetachRoleTypeDef",
    {
        "RoleName": str,
    },
)

DetachRolePolicyRequestRequestTypeDef = TypedDict(
    "DetachRolePolicyRequestRequestTypeDef",
    {
        "RoleName": str,
        "PolicyArn": str,
    },
)

DetachRolePolicyRequestRoleDetachPolicyTypeDef = TypedDict(
    "DetachRolePolicyRequestRoleDetachPolicyTypeDef",
    {
        "PolicyArn": str,
    },
)

DetachUserPolicyRequestPolicyDetachUserTypeDef = TypedDict(
    "DetachUserPolicyRequestPolicyDetachUserTypeDef",
    {
        "UserName": str,
    },
)

DetachUserPolicyRequestRequestTypeDef = TypedDict(
    "DetachUserPolicyRequestRequestTypeDef",
    {
        "UserName": str,
        "PolicyArn": str,
    },
)

DetachUserPolicyRequestUserDetachPolicyTypeDef = TypedDict(
    "DetachUserPolicyRequestUserDetachPolicyTypeDef",
    {
        "PolicyArn": str,
    },
)

EmptyResponseMetadataTypeDef = TypedDict(
    "EmptyResponseMetadataTypeDef",
    {
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

EnableMFADeviceRequestMfaDeviceAssociateTypeDef = TypedDict(
    "EnableMFADeviceRequestMfaDeviceAssociateTypeDef",
    {
        "AuthenticationCode1": str,
        "AuthenticationCode2": str,
    },
)

EnableMFADeviceRequestRequestTypeDef = TypedDict(
    "EnableMFADeviceRequestRequestTypeDef",
    {
        "UserName": str,
        "SerialNumber": str,
        "AuthenticationCode1": str,
        "AuthenticationCode2": str,
    },
)

EnableMFADeviceRequestUserEnableMfaTypeDef = TypedDict(
    "EnableMFADeviceRequestUserEnableMfaTypeDef",
    {
        "SerialNumber": str,
        "AuthenticationCode1": str,
        "AuthenticationCode2": str,
    },
)

EntityInfoOutputTypeDef = TypedDict(
    "EntityInfoOutputTypeDef",
    {
        "Arn": str,
        "Name": str,
        "Type": policyOwnerEntityTypeType,
        "Id": str,
        "Path": str,
    },
)

ErrorDetailsOutputTypeDef = TypedDict(
    "ErrorDetailsOutputTypeDef",
    {
        "Message": str,
        "Code": str,
    },
)

OrganizationsDecisionDetailOutputTypeDef = TypedDict(
    "OrganizationsDecisionDetailOutputTypeDef",
    {
        "AllowedByOrganizations": bool,
    },
)

PermissionsBoundaryDecisionDetailOutputTypeDef = TypedDict(
    "PermissionsBoundaryDecisionDetailOutputTypeDef",
    {
        "AllowedByPermissionsBoundary": bool,
    },
)

GenerateCredentialReportResponseOutputTypeDef = TypedDict(
    "GenerateCredentialReportResponseOutputTypeDef",
    {
        "State": ReportStateTypeType,
        "Description": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredGenerateOrganizationsAccessReportRequestRequestTypeDef = TypedDict(
    "_RequiredGenerateOrganizationsAccessReportRequestRequestTypeDef",
    {
        "EntityPath": str,
    },
)
_OptionalGenerateOrganizationsAccessReportRequestRequestTypeDef = TypedDict(
    "_OptionalGenerateOrganizationsAccessReportRequestRequestTypeDef",
    {
        "OrganizationsPolicyId": str,
    },
    total=False,
)


class GenerateOrganizationsAccessReportRequestRequestTypeDef(
    _RequiredGenerateOrganizationsAccessReportRequestRequestTypeDef,
    _OptionalGenerateOrganizationsAccessReportRequestRequestTypeDef,
):
    pass


GenerateOrganizationsAccessReportResponseOutputTypeDef = TypedDict(
    "GenerateOrganizationsAccessReportResponseOutputTypeDef",
    {
        "JobId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredGenerateServiceLastAccessedDetailsRequestRequestTypeDef = TypedDict(
    "_RequiredGenerateServiceLastAccessedDetailsRequestRequestTypeDef",
    {
        "Arn": str,
    },
)
_OptionalGenerateServiceLastAccessedDetailsRequestRequestTypeDef = TypedDict(
    "_OptionalGenerateServiceLastAccessedDetailsRequestRequestTypeDef",
    {
        "Granularity": AccessAdvisorUsageGranularityTypeType,
    },
    total=False,
)


class GenerateServiceLastAccessedDetailsRequestRequestTypeDef(
    _RequiredGenerateServiceLastAccessedDetailsRequestRequestTypeDef,
    _OptionalGenerateServiceLastAccessedDetailsRequestRequestTypeDef,
):
    pass


GenerateServiceLastAccessedDetailsResponseOutputTypeDef = TypedDict(
    "GenerateServiceLastAccessedDetailsResponseOutputTypeDef",
    {
        "JobId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetAccessKeyLastUsedRequestRequestTypeDef = TypedDict(
    "GetAccessKeyLastUsedRequestRequestTypeDef",
    {
        "AccessKeyId": str,
    },
)

GetAccountAuthorizationDetailsRequestGetAccountAuthorizationDetailsPaginateTypeDef = TypedDict(
    "GetAccountAuthorizationDetailsRequestGetAccountAuthorizationDetailsPaginateTypeDef",
    {
        "Filter": Sequence[EntityTypeType],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

GetAccountAuthorizationDetailsRequestRequestTypeDef = TypedDict(
    "GetAccountAuthorizationDetailsRequestRequestTypeDef",
    {
        "Filter": Sequence[EntityTypeType],
        "MaxItems": int,
        "Marker": str,
    },
    total=False,
)

PasswordPolicyOutputTypeDef = TypedDict(
    "PasswordPolicyOutputTypeDef",
    {
        "MinimumPasswordLength": int,
        "RequireSymbols": bool,
        "RequireNumbers": bool,
        "RequireUppercaseCharacters": bool,
        "RequireLowercaseCharacters": bool,
        "AllowUsersToChangePassword": bool,
        "ExpirePasswords": bool,
        "MaxPasswordAge": int,
        "PasswordReusePrevention": int,
        "HardExpiry": bool,
    },
)

GetAccountSummaryResponseOutputTypeDef = TypedDict(
    "GetAccountSummaryResponseOutputTypeDef",
    {
        "SummaryMap": Dict[summaryKeyTypeType, int],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetContextKeysForCustomPolicyRequestRequestTypeDef = TypedDict(
    "GetContextKeysForCustomPolicyRequestRequestTypeDef",
    {
        "PolicyInputList": Sequence[str],
    },
)

GetContextKeysForPolicyResponseOutputTypeDef = TypedDict(
    "GetContextKeysForPolicyResponseOutputTypeDef",
    {
        "ContextKeyNames": List[str],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredGetContextKeysForPrincipalPolicyRequestRequestTypeDef = TypedDict(
    "_RequiredGetContextKeysForPrincipalPolicyRequestRequestTypeDef",
    {
        "PolicySourceArn": str,
    },
)
_OptionalGetContextKeysForPrincipalPolicyRequestRequestTypeDef = TypedDict(
    "_OptionalGetContextKeysForPrincipalPolicyRequestRequestTypeDef",
    {
        "PolicyInputList": Sequence[str],
    },
    total=False,
)


class GetContextKeysForPrincipalPolicyRequestRequestTypeDef(
    _RequiredGetContextKeysForPrincipalPolicyRequestRequestTypeDef,
    _OptionalGetContextKeysForPrincipalPolicyRequestRequestTypeDef,
):
    pass


GetCredentialReportResponseOutputTypeDef = TypedDict(
    "GetCredentialReportResponseOutputTypeDef",
    {
        "Content": bytes,
        "ReportFormat": Literal["text/csv"],
        "GeneratedTime": datetime,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetGroupPolicyRequestRequestTypeDef = TypedDict(
    "GetGroupPolicyRequestRequestTypeDef",
    {
        "GroupName": str,
        "PolicyName": str,
    },
)

GetGroupPolicyResponseOutputTypeDef = TypedDict(
    "GetGroupPolicyResponseOutputTypeDef",
    {
        "GroupName": str,
        "PolicyName": str,
        "PolicyDocument": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredGetGroupRequestGetGroupPaginateTypeDef = TypedDict(
    "_RequiredGetGroupRequestGetGroupPaginateTypeDef",
    {
        "GroupName": str,
    },
)
_OptionalGetGroupRequestGetGroupPaginateTypeDef = TypedDict(
    "_OptionalGetGroupRequestGetGroupPaginateTypeDef",
    {
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class GetGroupRequestGetGroupPaginateTypeDef(
    _RequiredGetGroupRequestGetGroupPaginateTypeDef, _OptionalGetGroupRequestGetGroupPaginateTypeDef
):
    pass


_RequiredGetGroupRequestRequestTypeDef = TypedDict(
    "_RequiredGetGroupRequestRequestTypeDef",
    {
        "GroupName": str,
    },
)
_OptionalGetGroupRequestRequestTypeDef = TypedDict(
    "_OptionalGetGroupRequestRequestTypeDef",
    {
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)


class GetGroupRequestRequestTypeDef(
    _RequiredGetGroupRequestRequestTypeDef, _OptionalGetGroupRequestRequestTypeDef
):
    pass


WaiterConfigTypeDef = TypedDict(
    "WaiterConfigTypeDef",
    {
        "Delay": int,
        "MaxAttempts": int,
    },
    total=False,
)

GetInstanceProfileRequestRequestTypeDef = TypedDict(
    "GetInstanceProfileRequestRequestTypeDef",
    {
        "InstanceProfileName": str,
    },
)

GetLoginProfileRequestRequestTypeDef = TypedDict(
    "GetLoginProfileRequestRequestTypeDef",
    {
        "UserName": str,
    },
)

_RequiredGetMFADeviceRequestRequestTypeDef = TypedDict(
    "_RequiredGetMFADeviceRequestRequestTypeDef",
    {
        "SerialNumber": str,
    },
)
_OptionalGetMFADeviceRequestRequestTypeDef = TypedDict(
    "_OptionalGetMFADeviceRequestRequestTypeDef",
    {
        "UserName": str,
    },
    total=False,
)


class GetMFADeviceRequestRequestTypeDef(
    _RequiredGetMFADeviceRequestRequestTypeDef, _OptionalGetMFADeviceRequestRequestTypeDef
):
    pass


GetMFADeviceResponseOutputTypeDef = TypedDict(
    "GetMFADeviceResponseOutputTypeDef",
    {
        "UserName": str,
        "SerialNumber": str,
        "EnableDate": datetime,
        "Certifications": Dict[str, str],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetOpenIDConnectProviderRequestRequestTypeDef = TypedDict(
    "GetOpenIDConnectProviderRequestRequestTypeDef",
    {
        "OpenIDConnectProviderArn": str,
    },
)

_RequiredGetOrganizationsAccessReportRequestRequestTypeDef = TypedDict(
    "_RequiredGetOrganizationsAccessReportRequestRequestTypeDef",
    {
        "JobId": str,
    },
)
_OptionalGetOrganizationsAccessReportRequestRequestTypeDef = TypedDict(
    "_OptionalGetOrganizationsAccessReportRequestRequestTypeDef",
    {
        "MaxItems": int,
        "Marker": str,
        "SortKey": sortKeyTypeType,
    },
    total=False,
)


class GetOrganizationsAccessReportRequestRequestTypeDef(
    _RequiredGetOrganizationsAccessReportRequestRequestTypeDef,
    _OptionalGetOrganizationsAccessReportRequestRequestTypeDef,
):
    pass


GetPolicyRequestRequestTypeDef = TypedDict(
    "GetPolicyRequestRequestTypeDef",
    {
        "PolicyArn": str,
    },
)

GetPolicyVersionRequestRequestTypeDef = TypedDict(
    "GetPolicyVersionRequestRequestTypeDef",
    {
        "PolicyArn": str,
        "VersionId": str,
    },
)

GetRolePolicyRequestRequestTypeDef = TypedDict(
    "GetRolePolicyRequestRequestTypeDef",
    {
        "RoleName": str,
        "PolicyName": str,
    },
)

GetRolePolicyResponseOutputTypeDef = TypedDict(
    "GetRolePolicyResponseOutputTypeDef",
    {
        "RoleName": str,
        "PolicyName": str,
        "PolicyDocument": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetRoleRequestRequestTypeDef = TypedDict(
    "GetRoleRequestRequestTypeDef",
    {
        "RoleName": str,
    },
)

GetSAMLProviderRequestRequestTypeDef = TypedDict(
    "GetSAMLProviderRequestRequestTypeDef",
    {
        "SAMLProviderArn": str,
    },
)

GetSSHPublicKeyRequestRequestTypeDef = TypedDict(
    "GetSSHPublicKeyRequestRequestTypeDef",
    {
        "UserName": str,
        "SSHPublicKeyId": str,
        "Encoding": encodingTypeType,
    },
)

SSHPublicKeyOutputTypeDef = TypedDict(
    "SSHPublicKeyOutputTypeDef",
    {
        "UserName": str,
        "SSHPublicKeyId": str,
        "Fingerprint": str,
        "SSHPublicKeyBody": str,
        "Status": statusTypeType,
        "UploadDate": datetime,
    },
)

GetServerCertificateRequestRequestTypeDef = TypedDict(
    "GetServerCertificateRequestRequestTypeDef",
    {
        "ServerCertificateName": str,
    },
)

_RequiredGetServiceLastAccessedDetailsRequestRequestTypeDef = TypedDict(
    "_RequiredGetServiceLastAccessedDetailsRequestRequestTypeDef",
    {
        "JobId": str,
    },
)
_OptionalGetServiceLastAccessedDetailsRequestRequestTypeDef = TypedDict(
    "_OptionalGetServiceLastAccessedDetailsRequestRequestTypeDef",
    {
        "MaxItems": int,
        "Marker": str,
    },
    total=False,
)


class GetServiceLastAccessedDetailsRequestRequestTypeDef(
    _RequiredGetServiceLastAccessedDetailsRequestRequestTypeDef,
    _OptionalGetServiceLastAccessedDetailsRequestRequestTypeDef,
):
    pass


_RequiredGetServiceLastAccessedDetailsWithEntitiesRequestRequestTypeDef = TypedDict(
    "_RequiredGetServiceLastAccessedDetailsWithEntitiesRequestRequestTypeDef",
    {
        "JobId": str,
        "ServiceNamespace": str,
    },
)
_OptionalGetServiceLastAccessedDetailsWithEntitiesRequestRequestTypeDef = TypedDict(
    "_OptionalGetServiceLastAccessedDetailsWithEntitiesRequestRequestTypeDef",
    {
        "MaxItems": int,
        "Marker": str,
    },
    total=False,
)


class GetServiceLastAccessedDetailsWithEntitiesRequestRequestTypeDef(
    _RequiredGetServiceLastAccessedDetailsWithEntitiesRequestRequestTypeDef,
    _OptionalGetServiceLastAccessedDetailsWithEntitiesRequestRequestTypeDef,
):
    pass


GetServiceLinkedRoleDeletionStatusRequestRequestTypeDef = TypedDict(
    "GetServiceLinkedRoleDeletionStatusRequestRequestTypeDef",
    {
        "DeletionTaskId": str,
    },
)

GetUserPolicyRequestRequestTypeDef = TypedDict(
    "GetUserPolicyRequestRequestTypeDef",
    {
        "UserName": str,
        "PolicyName": str,
    },
)

GetUserPolicyResponseOutputTypeDef = TypedDict(
    "GetUserPolicyResponseOutputTypeDef",
    {
        "UserName": str,
        "PolicyName": str,
        "PolicyDocument": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetUserRequestRequestTypeDef = TypedDict(
    "GetUserRequestRequestTypeDef",
    {
        "UserName": str,
    },
    total=False,
)

PolicyDetailOutputTypeDef = TypedDict(
    "PolicyDetailOutputTypeDef",
    {
        "PolicyName": str,
        "PolicyDocument": str,
    },
)

ListAccessKeysRequestListAccessKeysPaginateTypeDef = TypedDict(
    "ListAccessKeysRequestListAccessKeysPaginateTypeDef",
    {
        "UserName": str,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

ListAccessKeysRequestRequestTypeDef = TypedDict(
    "ListAccessKeysRequestRequestTypeDef",
    {
        "UserName": str,
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)

ListAccountAliasesRequestListAccountAliasesPaginateTypeDef = TypedDict(
    "ListAccountAliasesRequestListAccountAliasesPaginateTypeDef",
    {
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

ListAccountAliasesRequestRequestTypeDef = TypedDict(
    "ListAccountAliasesRequestRequestTypeDef",
    {
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)

ListAccountAliasesResponseOutputTypeDef = TypedDict(
    "ListAccountAliasesResponseOutputTypeDef",
    {
        "AccountAliases": List[str],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredListAttachedGroupPoliciesRequestListAttachedGroupPoliciesPaginateTypeDef = TypedDict(
    "_RequiredListAttachedGroupPoliciesRequestListAttachedGroupPoliciesPaginateTypeDef",
    {
        "GroupName": str,
    },
)
_OptionalListAttachedGroupPoliciesRequestListAttachedGroupPoliciesPaginateTypeDef = TypedDict(
    "_OptionalListAttachedGroupPoliciesRequestListAttachedGroupPoliciesPaginateTypeDef",
    {
        "PathPrefix": str,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class ListAttachedGroupPoliciesRequestListAttachedGroupPoliciesPaginateTypeDef(
    _RequiredListAttachedGroupPoliciesRequestListAttachedGroupPoliciesPaginateTypeDef,
    _OptionalListAttachedGroupPoliciesRequestListAttachedGroupPoliciesPaginateTypeDef,
):
    pass


_RequiredListAttachedGroupPoliciesRequestRequestTypeDef = TypedDict(
    "_RequiredListAttachedGroupPoliciesRequestRequestTypeDef",
    {
        "GroupName": str,
    },
)
_OptionalListAttachedGroupPoliciesRequestRequestTypeDef = TypedDict(
    "_OptionalListAttachedGroupPoliciesRequestRequestTypeDef",
    {
        "PathPrefix": str,
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)


class ListAttachedGroupPoliciesRequestRequestTypeDef(
    _RequiredListAttachedGroupPoliciesRequestRequestTypeDef,
    _OptionalListAttachedGroupPoliciesRequestRequestTypeDef,
):
    pass


_RequiredListAttachedRolePoliciesRequestListAttachedRolePoliciesPaginateTypeDef = TypedDict(
    "_RequiredListAttachedRolePoliciesRequestListAttachedRolePoliciesPaginateTypeDef",
    {
        "RoleName": str,
    },
)
_OptionalListAttachedRolePoliciesRequestListAttachedRolePoliciesPaginateTypeDef = TypedDict(
    "_OptionalListAttachedRolePoliciesRequestListAttachedRolePoliciesPaginateTypeDef",
    {
        "PathPrefix": str,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class ListAttachedRolePoliciesRequestListAttachedRolePoliciesPaginateTypeDef(
    _RequiredListAttachedRolePoliciesRequestListAttachedRolePoliciesPaginateTypeDef,
    _OptionalListAttachedRolePoliciesRequestListAttachedRolePoliciesPaginateTypeDef,
):
    pass


_RequiredListAttachedRolePoliciesRequestRequestTypeDef = TypedDict(
    "_RequiredListAttachedRolePoliciesRequestRequestTypeDef",
    {
        "RoleName": str,
    },
)
_OptionalListAttachedRolePoliciesRequestRequestTypeDef = TypedDict(
    "_OptionalListAttachedRolePoliciesRequestRequestTypeDef",
    {
        "PathPrefix": str,
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)


class ListAttachedRolePoliciesRequestRequestTypeDef(
    _RequiredListAttachedRolePoliciesRequestRequestTypeDef,
    _OptionalListAttachedRolePoliciesRequestRequestTypeDef,
):
    pass


_RequiredListAttachedUserPoliciesRequestListAttachedUserPoliciesPaginateTypeDef = TypedDict(
    "_RequiredListAttachedUserPoliciesRequestListAttachedUserPoliciesPaginateTypeDef",
    {
        "UserName": str,
    },
)
_OptionalListAttachedUserPoliciesRequestListAttachedUserPoliciesPaginateTypeDef = TypedDict(
    "_OptionalListAttachedUserPoliciesRequestListAttachedUserPoliciesPaginateTypeDef",
    {
        "PathPrefix": str,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class ListAttachedUserPoliciesRequestListAttachedUserPoliciesPaginateTypeDef(
    _RequiredListAttachedUserPoliciesRequestListAttachedUserPoliciesPaginateTypeDef,
    _OptionalListAttachedUserPoliciesRequestListAttachedUserPoliciesPaginateTypeDef,
):
    pass


_RequiredListAttachedUserPoliciesRequestRequestTypeDef = TypedDict(
    "_RequiredListAttachedUserPoliciesRequestRequestTypeDef",
    {
        "UserName": str,
    },
)
_OptionalListAttachedUserPoliciesRequestRequestTypeDef = TypedDict(
    "_OptionalListAttachedUserPoliciesRequestRequestTypeDef",
    {
        "PathPrefix": str,
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)


class ListAttachedUserPoliciesRequestRequestTypeDef(
    _RequiredListAttachedUserPoliciesRequestRequestTypeDef,
    _OptionalListAttachedUserPoliciesRequestRequestTypeDef,
):
    pass


_RequiredListEntitiesForPolicyRequestListEntitiesForPolicyPaginateTypeDef = TypedDict(
    "_RequiredListEntitiesForPolicyRequestListEntitiesForPolicyPaginateTypeDef",
    {
        "PolicyArn": str,
    },
)
_OptionalListEntitiesForPolicyRequestListEntitiesForPolicyPaginateTypeDef = TypedDict(
    "_OptionalListEntitiesForPolicyRequestListEntitiesForPolicyPaginateTypeDef",
    {
        "EntityFilter": EntityTypeType,
        "PathPrefix": str,
        "PolicyUsageFilter": PolicyUsageTypeType,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class ListEntitiesForPolicyRequestListEntitiesForPolicyPaginateTypeDef(
    _RequiredListEntitiesForPolicyRequestListEntitiesForPolicyPaginateTypeDef,
    _OptionalListEntitiesForPolicyRequestListEntitiesForPolicyPaginateTypeDef,
):
    pass


_RequiredListEntitiesForPolicyRequestRequestTypeDef = TypedDict(
    "_RequiredListEntitiesForPolicyRequestRequestTypeDef",
    {
        "PolicyArn": str,
    },
)
_OptionalListEntitiesForPolicyRequestRequestTypeDef = TypedDict(
    "_OptionalListEntitiesForPolicyRequestRequestTypeDef",
    {
        "EntityFilter": EntityTypeType,
        "PathPrefix": str,
        "PolicyUsageFilter": PolicyUsageTypeType,
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)


class ListEntitiesForPolicyRequestRequestTypeDef(
    _RequiredListEntitiesForPolicyRequestRequestTypeDef,
    _OptionalListEntitiesForPolicyRequestRequestTypeDef,
):
    pass


PolicyGroupOutputTypeDef = TypedDict(
    "PolicyGroupOutputTypeDef",
    {
        "GroupName": str,
        "GroupId": str,
    },
)

PolicyRoleOutputTypeDef = TypedDict(
    "PolicyRoleOutputTypeDef",
    {
        "RoleName": str,
        "RoleId": str,
    },
)

PolicyUserOutputTypeDef = TypedDict(
    "PolicyUserOutputTypeDef",
    {
        "UserName": str,
        "UserId": str,
    },
)

_RequiredListGroupPoliciesRequestListGroupPoliciesPaginateTypeDef = TypedDict(
    "_RequiredListGroupPoliciesRequestListGroupPoliciesPaginateTypeDef",
    {
        "GroupName": str,
    },
)
_OptionalListGroupPoliciesRequestListGroupPoliciesPaginateTypeDef = TypedDict(
    "_OptionalListGroupPoliciesRequestListGroupPoliciesPaginateTypeDef",
    {
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class ListGroupPoliciesRequestListGroupPoliciesPaginateTypeDef(
    _RequiredListGroupPoliciesRequestListGroupPoliciesPaginateTypeDef,
    _OptionalListGroupPoliciesRequestListGroupPoliciesPaginateTypeDef,
):
    pass


_RequiredListGroupPoliciesRequestRequestTypeDef = TypedDict(
    "_RequiredListGroupPoliciesRequestRequestTypeDef",
    {
        "GroupName": str,
    },
)
_OptionalListGroupPoliciesRequestRequestTypeDef = TypedDict(
    "_OptionalListGroupPoliciesRequestRequestTypeDef",
    {
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)


class ListGroupPoliciesRequestRequestTypeDef(
    _RequiredListGroupPoliciesRequestRequestTypeDef, _OptionalListGroupPoliciesRequestRequestTypeDef
):
    pass


ListGroupPoliciesResponseOutputTypeDef = TypedDict(
    "ListGroupPoliciesResponseOutputTypeDef",
    {
        "PolicyNames": List[str],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredListGroupsForUserRequestListGroupsForUserPaginateTypeDef = TypedDict(
    "_RequiredListGroupsForUserRequestListGroupsForUserPaginateTypeDef",
    {
        "UserName": str,
    },
)
_OptionalListGroupsForUserRequestListGroupsForUserPaginateTypeDef = TypedDict(
    "_OptionalListGroupsForUserRequestListGroupsForUserPaginateTypeDef",
    {
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class ListGroupsForUserRequestListGroupsForUserPaginateTypeDef(
    _RequiredListGroupsForUserRequestListGroupsForUserPaginateTypeDef,
    _OptionalListGroupsForUserRequestListGroupsForUserPaginateTypeDef,
):
    pass


_RequiredListGroupsForUserRequestRequestTypeDef = TypedDict(
    "_RequiredListGroupsForUserRequestRequestTypeDef",
    {
        "UserName": str,
    },
)
_OptionalListGroupsForUserRequestRequestTypeDef = TypedDict(
    "_OptionalListGroupsForUserRequestRequestTypeDef",
    {
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)


class ListGroupsForUserRequestRequestTypeDef(
    _RequiredListGroupsForUserRequestRequestTypeDef, _OptionalListGroupsForUserRequestRequestTypeDef
):
    pass


ListGroupsRequestListGroupsPaginateTypeDef = TypedDict(
    "ListGroupsRequestListGroupsPaginateTypeDef",
    {
        "PathPrefix": str,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

ListGroupsRequestRequestTypeDef = TypedDict(
    "ListGroupsRequestRequestTypeDef",
    {
        "PathPrefix": str,
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)

_RequiredListInstanceProfileTagsRequestListInstanceProfileTagsPaginateTypeDef = TypedDict(
    "_RequiredListInstanceProfileTagsRequestListInstanceProfileTagsPaginateTypeDef",
    {
        "InstanceProfileName": str,
    },
)
_OptionalListInstanceProfileTagsRequestListInstanceProfileTagsPaginateTypeDef = TypedDict(
    "_OptionalListInstanceProfileTagsRequestListInstanceProfileTagsPaginateTypeDef",
    {
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class ListInstanceProfileTagsRequestListInstanceProfileTagsPaginateTypeDef(
    _RequiredListInstanceProfileTagsRequestListInstanceProfileTagsPaginateTypeDef,
    _OptionalListInstanceProfileTagsRequestListInstanceProfileTagsPaginateTypeDef,
):
    pass


_RequiredListInstanceProfileTagsRequestRequestTypeDef = TypedDict(
    "_RequiredListInstanceProfileTagsRequestRequestTypeDef",
    {
        "InstanceProfileName": str,
    },
)
_OptionalListInstanceProfileTagsRequestRequestTypeDef = TypedDict(
    "_OptionalListInstanceProfileTagsRequestRequestTypeDef",
    {
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)


class ListInstanceProfileTagsRequestRequestTypeDef(
    _RequiredListInstanceProfileTagsRequestRequestTypeDef,
    _OptionalListInstanceProfileTagsRequestRequestTypeDef,
):
    pass


_RequiredListInstanceProfilesForRoleRequestListInstanceProfilesForRolePaginateTypeDef = TypedDict(
    "_RequiredListInstanceProfilesForRoleRequestListInstanceProfilesForRolePaginateTypeDef",
    {
        "RoleName": str,
    },
)
_OptionalListInstanceProfilesForRoleRequestListInstanceProfilesForRolePaginateTypeDef = TypedDict(
    "_OptionalListInstanceProfilesForRoleRequestListInstanceProfilesForRolePaginateTypeDef",
    {
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class ListInstanceProfilesForRoleRequestListInstanceProfilesForRolePaginateTypeDef(
    _RequiredListInstanceProfilesForRoleRequestListInstanceProfilesForRolePaginateTypeDef,
    _OptionalListInstanceProfilesForRoleRequestListInstanceProfilesForRolePaginateTypeDef,
):
    pass


_RequiredListInstanceProfilesForRoleRequestRequestTypeDef = TypedDict(
    "_RequiredListInstanceProfilesForRoleRequestRequestTypeDef",
    {
        "RoleName": str,
    },
)
_OptionalListInstanceProfilesForRoleRequestRequestTypeDef = TypedDict(
    "_OptionalListInstanceProfilesForRoleRequestRequestTypeDef",
    {
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)


class ListInstanceProfilesForRoleRequestRequestTypeDef(
    _RequiredListInstanceProfilesForRoleRequestRequestTypeDef,
    _OptionalListInstanceProfilesForRoleRequestRequestTypeDef,
):
    pass


ListInstanceProfilesRequestListInstanceProfilesPaginateTypeDef = TypedDict(
    "ListInstanceProfilesRequestListInstanceProfilesPaginateTypeDef",
    {
        "PathPrefix": str,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

ListInstanceProfilesRequestRequestTypeDef = TypedDict(
    "ListInstanceProfilesRequestRequestTypeDef",
    {
        "PathPrefix": str,
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)

_RequiredListMFADeviceTagsRequestListMFADeviceTagsPaginateTypeDef = TypedDict(
    "_RequiredListMFADeviceTagsRequestListMFADeviceTagsPaginateTypeDef",
    {
        "SerialNumber": str,
    },
)
_OptionalListMFADeviceTagsRequestListMFADeviceTagsPaginateTypeDef = TypedDict(
    "_OptionalListMFADeviceTagsRequestListMFADeviceTagsPaginateTypeDef",
    {
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class ListMFADeviceTagsRequestListMFADeviceTagsPaginateTypeDef(
    _RequiredListMFADeviceTagsRequestListMFADeviceTagsPaginateTypeDef,
    _OptionalListMFADeviceTagsRequestListMFADeviceTagsPaginateTypeDef,
):
    pass


_RequiredListMFADeviceTagsRequestRequestTypeDef = TypedDict(
    "_RequiredListMFADeviceTagsRequestRequestTypeDef",
    {
        "SerialNumber": str,
    },
)
_OptionalListMFADeviceTagsRequestRequestTypeDef = TypedDict(
    "_OptionalListMFADeviceTagsRequestRequestTypeDef",
    {
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)


class ListMFADeviceTagsRequestRequestTypeDef(
    _RequiredListMFADeviceTagsRequestRequestTypeDef, _OptionalListMFADeviceTagsRequestRequestTypeDef
):
    pass


ListMFADevicesRequestListMFADevicesPaginateTypeDef = TypedDict(
    "ListMFADevicesRequestListMFADevicesPaginateTypeDef",
    {
        "UserName": str,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

ListMFADevicesRequestRequestTypeDef = TypedDict(
    "ListMFADevicesRequestRequestTypeDef",
    {
        "UserName": str,
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)

MFADeviceOutputTypeDef = TypedDict(
    "MFADeviceOutputTypeDef",
    {
        "UserName": str,
        "SerialNumber": str,
        "EnableDate": datetime,
    },
)

_RequiredListOpenIDConnectProviderTagsRequestListOpenIDConnectProviderTagsPaginateTypeDef = (
    TypedDict(
        "_RequiredListOpenIDConnectProviderTagsRequestListOpenIDConnectProviderTagsPaginateTypeDef",
        {
            "OpenIDConnectProviderArn": str,
        },
    )
)
_OptionalListOpenIDConnectProviderTagsRequestListOpenIDConnectProviderTagsPaginateTypeDef = (
    TypedDict(
        "_OptionalListOpenIDConnectProviderTagsRequestListOpenIDConnectProviderTagsPaginateTypeDef",
        {
            "PaginationConfig": "PaginatorConfigTypeDef",
        },
        total=False,
    )
)


class ListOpenIDConnectProviderTagsRequestListOpenIDConnectProviderTagsPaginateTypeDef(
    _RequiredListOpenIDConnectProviderTagsRequestListOpenIDConnectProviderTagsPaginateTypeDef,
    _OptionalListOpenIDConnectProviderTagsRequestListOpenIDConnectProviderTagsPaginateTypeDef,
):
    pass


_RequiredListOpenIDConnectProviderTagsRequestRequestTypeDef = TypedDict(
    "_RequiredListOpenIDConnectProviderTagsRequestRequestTypeDef",
    {
        "OpenIDConnectProviderArn": str,
    },
)
_OptionalListOpenIDConnectProviderTagsRequestRequestTypeDef = TypedDict(
    "_OptionalListOpenIDConnectProviderTagsRequestRequestTypeDef",
    {
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)


class ListOpenIDConnectProviderTagsRequestRequestTypeDef(
    _RequiredListOpenIDConnectProviderTagsRequestRequestTypeDef,
    _OptionalListOpenIDConnectProviderTagsRequestRequestTypeDef,
):
    pass


OpenIDConnectProviderListEntryOutputTypeDef = TypedDict(
    "OpenIDConnectProviderListEntryOutputTypeDef",
    {
        "Arn": str,
    },
)

PolicyGrantingServiceAccessOutputTypeDef = TypedDict(
    "PolicyGrantingServiceAccessOutputTypeDef",
    {
        "PolicyName": str,
        "PolicyType": policyTypeType,
        "PolicyArn": str,
        "EntityType": policyOwnerEntityTypeType,
        "EntityName": str,
    },
)

_RequiredListPoliciesGrantingServiceAccessRequestRequestTypeDef = TypedDict(
    "_RequiredListPoliciesGrantingServiceAccessRequestRequestTypeDef",
    {
        "Arn": str,
        "ServiceNamespaces": Sequence[str],
    },
)
_OptionalListPoliciesGrantingServiceAccessRequestRequestTypeDef = TypedDict(
    "_OptionalListPoliciesGrantingServiceAccessRequestRequestTypeDef",
    {
        "Marker": str,
    },
    total=False,
)


class ListPoliciesGrantingServiceAccessRequestRequestTypeDef(
    _RequiredListPoliciesGrantingServiceAccessRequestRequestTypeDef,
    _OptionalListPoliciesGrantingServiceAccessRequestRequestTypeDef,
):
    pass


ListPoliciesRequestListPoliciesPaginateTypeDef = TypedDict(
    "ListPoliciesRequestListPoliciesPaginateTypeDef",
    {
        "Scope": policyScopeTypeType,
        "OnlyAttached": bool,
        "PathPrefix": str,
        "PolicyUsageFilter": PolicyUsageTypeType,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

ListPoliciesRequestRequestTypeDef = TypedDict(
    "ListPoliciesRequestRequestTypeDef",
    {
        "Scope": policyScopeTypeType,
        "OnlyAttached": bool,
        "PathPrefix": str,
        "PolicyUsageFilter": PolicyUsageTypeType,
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)

_RequiredListPolicyTagsRequestListPolicyTagsPaginateTypeDef = TypedDict(
    "_RequiredListPolicyTagsRequestListPolicyTagsPaginateTypeDef",
    {
        "PolicyArn": str,
    },
)
_OptionalListPolicyTagsRequestListPolicyTagsPaginateTypeDef = TypedDict(
    "_OptionalListPolicyTagsRequestListPolicyTagsPaginateTypeDef",
    {
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class ListPolicyTagsRequestListPolicyTagsPaginateTypeDef(
    _RequiredListPolicyTagsRequestListPolicyTagsPaginateTypeDef,
    _OptionalListPolicyTagsRequestListPolicyTagsPaginateTypeDef,
):
    pass


_RequiredListPolicyTagsRequestRequestTypeDef = TypedDict(
    "_RequiredListPolicyTagsRequestRequestTypeDef",
    {
        "PolicyArn": str,
    },
)
_OptionalListPolicyTagsRequestRequestTypeDef = TypedDict(
    "_OptionalListPolicyTagsRequestRequestTypeDef",
    {
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)


class ListPolicyTagsRequestRequestTypeDef(
    _RequiredListPolicyTagsRequestRequestTypeDef, _OptionalListPolicyTagsRequestRequestTypeDef
):
    pass


_RequiredListPolicyVersionsRequestListPolicyVersionsPaginateTypeDef = TypedDict(
    "_RequiredListPolicyVersionsRequestListPolicyVersionsPaginateTypeDef",
    {
        "PolicyArn": str,
    },
)
_OptionalListPolicyVersionsRequestListPolicyVersionsPaginateTypeDef = TypedDict(
    "_OptionalListPolicyVersionsRequestListPolicyVersionsPaginateTypeDef",
    {
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class ListPolicyVersionsRequestListPolicyVersionsPaginateTypeDef(
    _RequiredListPolicyVersionsRequestListPolicyVersionsPaginateTypeDef,
    _OptionalListPolicyVersionsRequestListPolicyVersionsPaginateTypeDef,
):
    pass


_RequiredListPolicyVersionsRequestRequestTypeDef = TypedDict(
    "_RequiredListPolicyVersionsRequestRequestTypeDef",
    {
        "PolicyArn": str,
    },
)
_OptionalListPolicyVersionsRequestRequestTypeDef = TypedDict(
    "_OptionalListPolicyVersionsRequestRequestTypeDef",
    {
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)


class ListPolicyVersionsRequestRequestTypeDef(
    _RequiredListPolicyVersionsRequestRequestTypeDef,
    _OptionalListPolicyVersionsRequestRequestTypeDef,
):
    pass


_RequiredListRolePoliciesRequestListRolePoliciesPaginateTypeDef = TypedDict(
    "_RequiredListRolePoliciesRequestListRolePoliciesPaginateTypeDef",
    {
        "RoleName": str,
    },
)
_OptionalListRolePoliciesRequestListRolePoliciesPaginateTypeDef = TypedDict(
    "_OptionalListRolePoliciesRequestListRolePoliciesPaginateTypeDef",
    {
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class ListRolePoliciesRequestListRolePoliciesPaginateTypeDef(
    _RequiredListRolePoliciesRequestListRolePoliciesPaginateTypeDef,
    _OptionalListRolePoliciesRequestListRolePoliciesPaginateTypeDef,
):
    pass


_RequiredListRolePoliciesRequestRequestTypeDef = TypedDict(
    "_RequiredListRolePoliciesRequestRequestTypeDef",
    {
        "RoleName": str,
    },
)
_OptionalListRolePoliciesRequestRequestTypeDef = TypedDict(
    "_OptionalListRolePoliciesRequestRequestTypeDef",
    {
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)


class ListRolePoliciesRequestRequestTypeDef(
    _RequiredListRolePoliciesRequestRequestTypeDef, _OptionalListRolePoliciesRequestRequestTypeDef
):
    pass


ListRolePoliciesResponseOutputTypeDef = TypedDict(
    "ListRolePoliciesResponseOutputTypeDef",
    {
        "PolicyNames": List[str],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredListRoleTagsRequestListRoleTagsPaginateTypeDef = TypedDict(
    "_RequiredListRoleTagsRequestListRoleTagsPaginateTypeDef",
    {
        "RoleName": str,
    },
)
_OptionalListRoleTagsRequestListRoleTagsPaginateTypeDef = TypedDict(
    "_OptionalListRoleTagsRequestListRoleTagsPaginateTypeDef",
    {
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class ListRoleTagsRequestListRoleTagsPaginateTypeDef(
    _RequiredListRoleTagsRequestListRoleTagsPaginateTypeDef,
    _OptionalListRoleTagsRequestListRoleTagsPaginateTypeDef,
):
    pass


_RequiredListRoleTagsRequestRequestTypeDef = TypedDict(
    "_RequiredListRoleTagsRequestRequestTypeDef",
    {
        "RoleName": str,
    },
)
_OptionalListRoleTagsRequestRequestTypeDef = TypedDict(
    "_OptionalListRoleTagsRequestRequestTypeDef",
    {
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)


class ListRoleTagsRequestRequestTypeDef(
    _RequiredListRoleTagsRequestRequestTypeDef, _OptionalListRoleTagsRequestRequestTypeDef
):
    pass


ListRolesRequestListRolesPaginateTypeDef = TypedDict(
    "ListRolesRequestListRolesPaginateTypeDef",
    {
        "PathPrefix": str,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

ListRolesRequestRequestTypeDef = TypedDict(
    "ListRolesRequestRequestTypeDef",
    {
        "PathPrefix": str,
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)

_RequiredListSAMLProviderTagsRequestListSAMLProviderTagsPaginateTypeDef = TypedDict(
    "_RequiredListSAMLProviderTagsRequestListSAMLProviderTagsPaginateTypeDef",
    {
        "SAMLProviderArn": str,
    },
)
_OptionalListSAMLProviderTagsRequestListSAMLProviderTagsPaginateTypeDef = TypedDict(
    "_OptionalListSAMLProviderTagsRequestListSAMLProviderTagsPaginateTypeDef",
    {
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class ListSAMLProviderTagsRequestListSAMLProviderTagsPaginateTypeDef(
    _RequiredListSAMLProviderTagsRequestListSAMLProviderTagsPaginateTypeDef,
    _OptionalListSAMLProviderTagsRequestListSAMLProviderTagsPaginateTypeDef,
):
    pass


_RequiredListSAMLProviderTagsRequestRequestTypeDef = TypedDict(
    "_RequiredListSAMLProviderTagsRequestRequestTypeDef",
    {
        "SAMLProviderArn": str,
    },
)
_OptionalListSAMLProviderTagsRequestRequestTypeDef = TypedDict(
    "_OptionalListSAMLProviderTagsRequestRequestTypeDef",
    {
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)


class ListSAMLProviderTagsRequestRequestTypeDef(
    _RequiredListSAMLProviderTagsRequestRequestTypeDef,
    _OptionalListSAMLProviderTagsRequestRequestTypeDef,
):
    pass


SAMLProviderListEntryOutputTypeDef = TypedDict(
    "SAMLProviderListEntryOutputTypeDef",
    {
        "Arn": str,
        "ValidUntil": datetime,
        "CreateDate": datetime,
    },
)

ListSSHPublicKeysRequestListSSHPublicKeysPaginateTypeDef = TypedDict(
    "ListSSHPublicKeysRequestListSSHPublicKeysPaginateTypeDef",
    {
        "UserName": str,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

ListSSHPublicKeysRequestRequestTypeDef = TypedDict(
    "ListSSHPublicKeysRequestRequestTypeDef",
    {
        "UserName": str,
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)

SSHPublicKeyMetadataOutputTypeDef = TypedDict(
    "SSHPublicKeyMetadataOutputTypeDef",
    {
        "UserName": str,
        "SSHPublicKeyId": str,
        "Status": statusTypeType,
        "UploadDate": datetime,
    },
)

_RequiredListServerCertificateTagsRequestListServerCertificateTagsPaginateTypeDef = TypedDict(
    "_RequiredListServerCertificateTagsRequestListServerCertificateTagsPaginateTypeDef",
    {
        "ServerCertificateName": str,
    },
)
_OptionalListServerCertificateTagsRequestListServerCertificateTagsPaginateTypeDef = TypedDict(
    "_OptionalListServerCertificateTagsRequestListServerCertificateTagsPaginateTypeDef",
    {
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class ListServerCertificateTagsRequestListServerCertificateTagsPaginateTypeDef(
    _RequiredListServerCertificateTagsRequestListServerCertificateTagsPaginateTypeDef,
    _OptionalListServerCertificateTagsRequestListServerCertificateTagsPaginateTypeDef,
):
    pass


_RequiredListServerCertificateTagsRequestRequestTypeDef = TypedDict(
    "_RequiredListServerCertificateTagsRequestRequestTypeDef",
    {
        "ServerCertificateName": str,
    },
)
_OptionalListServerCertificateTagsRequestRequestTypeDef = TypedDict(
    "_OptionalListServerCertificateTagsRequestRequestTypeDef",
    {
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)


class ListServerCertificateTagsRequestRequestTypeDef(
    _RequiredListServerCertificateTagsRequestRequestTypeDef,
    _OptionalListServerCertificateTagsRequestRequestTypeDef,
):
    pass


ListServerCertificatesRequestListServerCertificatesPaginateTypeDef = TypedDict(
    "ListServerCertificatesRequestListServerCertificatesPaginateTypeDef",
    {
        "PathPrefix": str,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

ListServerCertificatesRequestRequestTypeDef = TypedDict(
    "ListServerCertificatesRequestRequestTypeDef",
    {
        "PathPrefix": str,
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)

ServerCertificateMetadataOutputTypeDef = TypedDict(
    "ServerCertificateMetadataOutputTypeDef",
    {
        "Path": str,
        "ServerCertificateName": str,
        "ServerCertificateId": str,
        "Arn": str,
        "UploadDate": datetime,
        "Expiration": datetime,
    },
)

ListServiceSpecificCredentialsRequestRequestTypeDef = TypedDict(
    "ListServiceSpecificCredentialsRequestRequestTypeDef",
    {
        "UserName": str,
        "ServiceName": str,
    },
    total=False,
)

ServiceSpecificCredentialMetadataOutputTypeDef = TypedDict(
    "ServiceSpecificCredentialMetadataOutputTypeDef",
    {
        "UserName": str,
        "Status": statusTypeType,
        "ServiceUserName": str,
        "CreateDate": datetime,
        "ServiceSpecificCredentialId": str,
        "ServiceName": str,
    },
)

ListSigningCertificatesRequestListSigningCertificatesPaginateTypeDef = TypedDict(
    "ListSigningCertificatesRequestListSigningCertificatesPaginateTypeDef",
    {
        "UserName": str,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

ListSigningCertificatesRequestRequestTypeDef = TypedDict(
    "ListSigningCertificatesRequestRequestTypeDef",
    {
        "UserName": str,
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)

SigningCertificateOutputTypeDef = TypedDict(
    "SigningCertificateOutputTypeDef",
    {
        "UserName": str,
        "CertificateId": str,
        "CertificateBody": str,
        "Status": statusTypeType,
        "UploadDate": datetime,
    },
)

_RequiredListUserPoliciesRequestListUserPoliciesPaginateTypeDef = TypedDict(
    "_RequiredListUserPoliciesRequestListUserPoliciesPaginateTypeDef",
    {
        "UserName": str,
    },
)
_OptionalListUserPoliciesRequestListUserPoliciesPaginateTypeDef = TypedDict(
    "_OptionalListUserPoliciesRequestListUserPoliciesPaginateTypeDef",
    {
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class ListUserPoliciesRequestListUserPoliciesPaginateTypeDef(
    _RequiredListUserPoliciesRequestListUserPoliciesPaginateTypeDef,
    _OptionalListUserPoliciesRequestListUserPoliciesPaginateTypeDef,
):
    pass


_RequiredListUserPoliciesRequestRequestTypeDef = TypedDict(
    "_RequiredListUserPoliciesRequestRequestTypeDef",
    {
        "UserName": str,
    },
)
_OptionalListUserPoliciesRequestRequestTypeDef = TypedDict(
    "_OptionalListUserPoliciesRequestRequestTypeDef",
    {
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)


class ListUserPoliciesRequestRequestTypeDef(
    _RequiredListUserPoliciesRequestRequestTypeDef, _OptionalListUserPoliciesRequestRequestTypeDef
):
    pass


ListUserPoliciesResponseOutputTypeDef = TypedDict(
    "ListUserPoliciesResponseOutputTypeDef",
    {
        "PolicyNames": List[str],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredListUserTagsRequestListUserTagsPaginateTypeDef = TypedDict(
    "_RequiredListUserTagsRequestListUserTagsPaginateTypeDef",
    {
        "UserName": str,
    },
)
_OptionalListUserTagsRequestListUserTagsPaginateTypeDef = TypedDict(
    "_OptionalListUserTagsRequestListUserTagsPaginateTypeDef",
    {
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class ListUserTagsRequestListUserTagsPaginateTypeDef(
    _RequiredListUserTagsRequestListUserTagsPaginateTypeDef,
    _OptionalListUserTagsRequestListUserTagsPaginateTypeDef,
):
    pass


_RequiredListUserTagsRequestRequestTypeDef = TypedDict(
    "_RequiredListUserTagsRequestRequestTypeDef",
    {
        "UserName": str,
    },
)
_OptionalListUserTagsRequestRequestTypeDef = TypedDict(
    "_OptionalListUserTagsRequestRequestTypeDef",
    {
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)


class ListUserTagsRequestRequestTypeDef(
    _RequiredListUserTagsRequestRequestTypeDef, _OptionalListUserTagsRequestRequestTypeDef
):
    pass


ListUsersRequestListUsersPaginateTypeDef = TypedDict(
    "ListUsersRequestListUsersPaginateTypeDef",
    {
        "PathPrefix": str,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

ListUsersRequestRequestTypeDef = TypedDict(
    "ListUsersRequestRequestTypeDef",
    {
        "PathPrefix": str,
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)

ListVirtualMFADevicesRequestListVirtualMFADevicesPaginateTypeDef = TypedDict(
    "ListVirtualMFADevicesRequestListVirtualMFADevicesPaginateTypeDef",
    {
        "AssignmentStatus": assignmentStatusTypeType,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

ListVirtualMFADevicesRequestRequestTypeDef = TypedDict(
    "ListVirtualMFADevicesRequestRequestTypeDef",
    {
        "AssignmentStatus": assignmentStatusTypeType,
        "Marker": str,
        "MaxItems": int,
    },
    total=False,
)

PaginatorConfigTypeDef = TypedDict(
    "PaginatorConfigTypeDef",
    {
        "MaxItems": int,
        "PageSize": int,
        "StartingToken": str,
    },
    total=False,
)

PositionOutputTypeDef = TypedDict(
    "PositionOutputTypeDef",
    {
        "Line": int,
        "Column": int,
    },
)

PutGroupPolicyRequestGroupCreatePolicyTypeDef = TypedDict(
    "PutGroupPolicyRequestGroupCreatePolicyTypeDef",
    {
        "PolicyName": str,
        "PolicyDocument": str,
    },
)

PutGroupPolicyRequestGroupPolicyPutTypeDef = TypedDict(
    "PutGroupPolicyRequestGroupPolicyPutTypeDef",
    {
        "PolicyDocument": str,
    },
)

PutGroupPolicyRequestRequestTypeDef = TypedDict(
    "PutGroupPolicyRequestRequestTypeDef",
    {
        "GroupName": str,
        "PolicyName": str,
        "PolicyDocument": str,
    },
)

PutRolePermissionsBoundaryRequestRequestTypeDef = TypedDict(
    "PutRolePermissionsBoundaryRequestRequestTypeDef",
    {
        "RoleName": str,
        "PermissionsBoundary": str,
    },
)

PutRolePolicyRequestRequestTypeDef = TypedDict(
    "PutRolePolicyRequestRequestTypeDef",
    {
        "RoleName": str,
        "PolicyName": str,
        "PolicyDocument": str,
    },
)

PutRolePolicyRequestRolePolicyPutTypeDef = TypedDict(
    "PutRolePolicyRequestRolePolicyPutTypeDef",
    {
        "PolicyDocument": str,
    },
)

PutUserPermissionsBoundaryRequestRequestTypeDef = TypedDict(
    "PutUserPermissionsBoundaryRequestRequestTypeDef",
    {
        "UserName": str,
        "PermissionsBoundary": str,
    },
)

PutUserPolicyRequestRequestTypeDef = TypedDict(
    "PutUserPolicyRequestRequestTypeDef",
    {
        "UserName": str,
        "PolicyName": str,
        "PolicyDocument": str,
    },
)

PutUserPolicyRequestUserCreatePolicyTypeDef = TypedDict(
    "PutUserPolicyRequestUserCreatePolicyTypeDef",
    {
        "PolicyName": str,
        "PolicyDocument": str,
    },
)

PutUserPolicyRequestUserPolicyPutTypeDef = TypedDict(
    "PutUserPolicyRequestUserPolicyPutTypeDef",
    {
        "PolicyDocument": str,
    },
)

RemoveClientIDFromOpenIDConnectProviderRequestRequestTypeDef = TypedDict(
    "RemoveClientIDFromOpenIDConnectProviderRequestRequestTypeDef",
    {
        "OpenIDConnectProviderArn": str,
        "ClientID": str,
    },
)

RemoveRoleFromInstanceProfileRequestInstanceProfileRemoveRoleTypeDef = TypedDict(
    "RemoveRoleFromInstanceProfileRequestInstanceProfileRemoveRoleTypeDef",
    {
        "RoleName": str,
    },
)

RemoveRoleFromInstanceProfileRequestRequestTypeDef = TypedDict(
    "RemoveRoleFromInstanceProfileRequestRequestTypeDef",
    {
        "InstanceProfileName": str,
        "RoleName": str,
    },
)

RemoveUserFromGroupRequestGroupRemoveUserTypeDef = TypedDict(
    "RemoveUserFromGroupRequestGroupRemoveUserTypeDef",
    {
        "UserName": str,
    },
)

RemoveUserFromGroupRequestRequestTypeDef = TypedDict(
    "RemoveUserFromGroupRequestRequestTypeDef",
    {
        "GroupName": str,
        "UserName": str,
    },
)

RemoveUserFromGroupRequestUserRemoveGroupTypeDef = TypedDict(
    "RemoveUserFromGroupRequestUserRemoveGroupTypeDef",
    {
        "GroupName": str,
    },
)

_RequiredResetServiceSpecificCredentialRequestRequestTypeDef = TypedDict(
    "_RequiredResetServiceSpecificCredentialRequestRequestTypeDef",
    {
        "ServiceSpecificCredentialId": str,
    },
)
_OptionalResetServiceSpecificCredentialRequestRequestTypeDef = TypedDict(
    "_OptionalResetServiceSpecificCredentialRequestRequestTypeDef",
    {
        "UserName": str,
    },
    total=False,
)


class ResetServiceSpecificCredentialRequestRequestTypeDef(
    _RequiredResetServiceSpecificCredentialRequestRequestTypeDef,
    _OptionalResetServiceSpecificCredentialRequestRequestTypeDef,
):
    pass


ResponseMetadataTypeDef = TypedDict(
    "ResponseMetadataTypeDef",
    {
        "RequestId": str,
        "HostId": str,
        "HTTPStatusCode": int,
        "HTTPHeaders": Dict[str, str],
        "RetryAttempts": int,
    },
)

ResyncMFADeviceRequestMfaDeviceResyncTypeDef = TypedDict(
    "ResyncMFADeviceRequestMfaDeviceResyncTypeDef",
    {
        "AuthenticationCode1": str,
        "AuthenticationCode2": str,
    },
)

ResyncMFADeviceRequestRequestTypeDef = TypedDict(
    "ResyncMFADeviceRequestRequestTypeDef",
    {
        "UserName": str,
        "SerialNumber": str,
        "AuthenticationCode1": str,
        "AuthenticationCode2": str,
    },
)

RoleLastUsedOutputTypeDef = TypedDict(
    "RoleLastUsedOutputTypeDef",
    {
        "LastUsedDate": datetime,
        "Region": str,
    },
)

RoleLastUsedResponseMetadataTypeDef = TypedDict(
    "RoleLastUsedResponseMetadataTypeDef",
    {
        "LastUsedDate": datetime,
        "Region": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ServerCertificateMetadataResponseMetadataTypeDef = TypedDict(
    "ServerCertificateMetadataResponseMetadataTypeDef",
    {
        "Path": str,
        "ServerCertificateName": str,
        "ServerCertificateId": str,
        "Arn": str,
        "UploadDate": datetime,
        "Expiration": datetime,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

TrackedActionLastAccessedOutputTypeDef = TypedDict(
    "TrackedActionLastAccessedOutputTypeDef",
    {
        "ActionName": str,
        "LastAccessedEntity": str,
        "LastAccessedTime": datetime,
        "LastAccessedRegion": str,
    },
)

SetDefaultPolicyVersionRequestRequestTypeDef = TypedDict(
    "SetDefaultPolicyVersionRequestRequestTypeDef",
    {
        "PolicyArn": str,
        "VersionId": str,
    },
)

SetSecurityTokenServicePreferencesRequestRequestTypeDef = TypedDict(
    "SetSecurityTokenServicePreferencesRequestRequestTypeDef",
    {
        "GlobalEndpointTokenVersion": globalEndpointTokenVersionType,
    },
)

UntagInstanceProfileRequestRequestTypeDef = TypedDict(
    "UntagInstanceProfileRequestRequestTypeDef",
    {
        "InstanceProfileName": str,
        "TagKeys": Sequence[str],
    },
)

UntagMFADeviceRequestRequestTypeDef = TypedDict(
    "UntagMFADeviceRequestRequestTypeDef",
    {
        "SerialNumber": str,
        "TagKeys": Sequence[str],
    },
)

UntagOpenIDConnectProviderRequestRequestTypeDef = TypedDict(
    "UntagOpenIDConnectProviderRequestRequestTypeDef",
    {
        "OpenIDConnectProviderArn": str,
        "TagKeys": Sequence[str],
    },
)

UntagPolicyRequestRequestTypeDef = TypedDict(
    "UntagPolicyRequestRequestTypeDef",
    {
        "PolicyArn": str,
        "TagKeys": Sequence[str],
    },
)

UntagRoleRequestRequestTypeDef = TypedDict(
    "UntagRoleRequestRequestTypeDef",
    {
        "RoleName": str,
        "TagKeys": Sequence[str],
    },
)

UntagSAMLProviderRequestRequestTypeDef = TypedDict(
    "UntagSAMLProviderRequestRequestTypeDef",
    {
        "SAMLProviderArn": str,
        "TagKeys": Sequence[str],
    },
)

UntagServerCertificateRequestRequestTypeDef = TypedDict(
    "UntagServerCertificateRequestRequestTypeDef",
    {
        "ServerCertificateName": str,
        "TagKeys": Sequence[str],
    },
)

UntagUserRequestRequestTypeDef = TypedDict(
    "UntagUserRequestRequestTypeDef",
    {
        "UserName": str,
        "TagKeys": Sequence[str],
    },
)

UpdateAccessKeyRequestAccessKeyActivateTypeDef = TypedDict(
    "UpdateAccessKeyRequestAccessKeyActivateTypeDef",
    {
        "Status": statusTypeType,
    },
    total=False,
)

UpdateAccessKeyRequestAccessKeyDeactivateTypeDef = TypedDict(
    "UpdateAccessKeyRequestAccessKeyDeactivateTypeDef",
    {
        "Status": statusTypeType,
    },
    total=False,
)

UpdateAccessKeyRequestAccessKeyPairActivateTypeDef = TypedDict(
    "UpdateAccessKeyRequestAccessKeyPairActivateTypeDef",
    {
        "Status": statusTypeType,
    },
    total=False,
)

UpdateAccessKeyRequestAccessKeyPairDeactivateTypeDef = TypedDict(
    "UpdateAccessKeyRequestAccessKeyPairDeactivateTypeDef",
    {
        "Status": statusTypeType,
    },
    total=False,
)

_RequiredUpdateAccessKeyRequestRequestTypeDef = TypedDict(
    "_RequiredUpdateAccessKeyRequestRequestTypeDef",
    {
        "AccessKeyId": str,
        "Status": statusTypeType,
    },
)
_OptionalUpdateAccessKeyRequestRequestTypeDef = TypedDict(
    "_OptionalUpdateAccessKeyRequestRequestTypeDef",
    {
        "UserName": str,
    },
    total=False,
)


class UpdateAccessKeyRequestRequestTypeDef(
    _RequiredUpdateAccessKeyRequestRequestTypeDef, _OptionalUpdateAccessKeyRequestRequestTypeDef
):
    pass


UpdateAccountPasswordPolicyRequestAccountPasswordPolicyUpdateTypeDef = TypedDict(
    "UpdateAccountPasswordPolicyRequestAccountPasswordPolicyUpdateTypeDef",
    {
        "MinimumPasswordLength": int,
        "RequireSymbols": bool,
        "RequireNumbers": bool,
        "RequireUppercaseCharacters": bool,
        "RequireLowercaseCharacters": bool,
        "AllowUsersToChangePassword": bool,
        "MaxPasswordAge": int,
        "PasswordReusePrevention": int,
        "HardExpiry": bool,
    },
    total=False,
)

UpdateAccountPasswordPolicyRequestRequestTypeDef = TypedDict(
    "UpdateAccountPasswordPolicyRequestRequestTypeDef",
    {
        "MinimumPasswordLength": int,
        "RequireSymbols": bool,
        "RequireNumbers": bool,
        "RequireUppercaseCharacters": bool,
        "RequireLowercaseCharacters": bool,
        "AllowUsersToChangePassword": bool,
        "MaxPasswordAge": int,
        "PasswordReusePrevention": int,
        "HardExpiry": bool,
    },
    total=False,
)

UpdateAccountPasswordPolicyRequestServiceResourceCreateAccountPasswordPolicyTypeDef = TypedDict(
    "UpdateAccountPasswordPolicyRequestServiceResourceCreateAccountPasswordPolicyTypeDef",
    {
        "MinimumPasswordLength": int,
        "RequireSymbols": bool,
        "RequireNumbers": bool,
        "RequireUppercaseCharacters": bool,
        "RequireLowercaseCharacters": bool,
        "AllowUsersToChangePassword": bool,
        "MaxPasswordAge": int,
        "PasswordReusePrevention": int,
        "HardExpiry": bool,
    },
    total=False,
)

UpdateAssumeRolePolicyRequestAssumeRolePolicyUpdateTypeDef = TypedDict(
    "UpdateAssumeRolePolicyRequestAssumeRolePolicyUpdateTypeDef",
    {
        "PolicyDocument": str,
    },
)

UpdateAssumeRolePolicyRequestRequestTypeDef = TypedDict(
    "UpdateAssumeRolePolicyRequestRequestTypeDef",
    {
        "RoleName": str,
        "PolicyDocument": str,
    },
)

UpdateGroupRequestGroupUpdateTypeDef = TypedDict(
    "UpdateGroupRequestGroupUpdateTypeDef",
    {
        "NewPath": str,
        "NewGroupName": str,
    },
    total=False,
)

_RequiredUpdateGroupRequestRequestTypeDef = TypedDict(
    "_RequiredUpdateGroupRequestRequestTypeDef",
    {
        "GroupName": str,
    },
)
_OptionalUpdateGroupRequestRequestTypeDef = TypedDict(
    "_OptionalUpdateGroupRequestRequestTypeDef",
    {
        "NewPath": str,
        "NewGroupName": str,
    },
    total=False,
)


class UpdateGroupRequestRequestTypeDef(
    _RequiredUpdateGroupRequestRequestTypeDef, _OptionalUpdateGroupRequestRequestTypeDef
):
    pass


UpdateLoginProfileRequestLoginProfileUpdateTypeDef = TypedDict(
    "UpdateLoginProfileRequestLoginProfileUpdateTypeDef",
    {
        "Password": str,
        "PasswordResetRequired": bool,
    },
    total=False,
)

_RequiredUpdateLoginProfileRequestRequestTypeDef = TypedDict(
    "_RequiredUpdateLoginProfileRequestRequestTypeDef",
    {
        "UserName": str,
    },
)
_OptionalUpdateLoginProfileRequestRequestTypeDef = TypedDict(
    "_OptionalUpdateLoginProfileRequestRequestTypeDef",
    {
        "Password": str,
        "PasswordResetRequired": bool,
    },
    total=False,
)


class UpdateLoginProfileRequestRequestTypeDef(
    _RequiredUpdateLoginProfileRequestRequestTypeDef,
    _OptionalUpdateLoginProfileRequestRequestTypeDef,
):
    pass


UpdateOpenIDConnectProviderThumbprintRequestRequestTypeDef = TypedDict(
    "UpdateOpenIDConnectProviderThumbprintRequestRequestTypeDef",
    {
        "OpenIDConnectProviderArn": str,
        "ThumbprintList": Sequence[str],
    },
)

UpdateRoleDescriptionRequestRequestTypeDef = TypedDict(
    "UpdateRoleDescriptionRequestRequestTypeDef",
    {
        "RoleName": str,
        "Description": str,
    },
)

_RequiredUpdateRoleRequestRequestTypeDef = TypedDict(
    "_RequiredUpdateRoleRequestRequestTypeDef",
    {
        "RoleName": str,
    },
)
_OptionalUpdateRoleRequestRequestTypeDef = TypedDict(
    "_OptionalUpdateRoleRequestRequestTypeDef",
    {
        "Description": str,
        "MaxSessionDuration": int,
    },
    total=False,
)


class UpdateRoleRequestRequestTypeDef(
    _RequiredUpdateRoleRequestRequestTypeDef, _OptionalUpdateRoleRequestRequestTypeDef
):
    pass


UpdateSAMLProviderRequestRequestTypeDef = TypedDict(
    "UpdateSAMLProviderRequestRequestTypeDef",
    {
        "SAMLMetadataDocument": str,
        "SAMLProviderArn": str,
    },
)

UpdateSAMLProviderRequestSamlProviderUpdateTypeDef = TypedDict(
    "UpdateSAMLProviderRequestSamlProviderUpdateTypeDef",
    {
        "SAMLMetadataDocument": str,
    },
)

UpdateSAMLProviderResponseOutputTypeDef = TypedDict(
    "UpdateSAMLProviderResponseOutputTypeDef",
    {
        "SAMLProviderArn": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

UpdateSSHPublicKeyRequestRequestTypeDef = TypedDict(
    "UpdateSSHPublicKeyRequestRequestTypeDef",
    {
        "UserName": str,
        "SSHPublicKeyId": str,
        "Status": statusTypeType,
    },
)

_RequiredUpdateServerCertificateRequestRequestTypeDef = TypedDict(
    "_RequiredUpdateServerCertificateRequestRequestTypeDef",
    {
        "ServerCertificateName": str,
    },
)
_OptionalUpdateServerCertificateRequestRequestTypeDef = TypedDict(
    "_OptionalUpdateServerCertificateRequestRequestTypeDef",
    {
        "NewPath": str,
        "NewServerCertificateName": str,
    },
    total=False,
)


class UpdateServerCertificateRequestRequestTypeDef(
    _RequiredUpdateServerCertificateRequestRequestTypeDef,
    _OptionalUpdateServerCertificateRequestRequestTypeDef,
):
    pass


UpdateServerCertificateRequestServerCertificateUpdateTypeDef = TypedDict(
    "UpdateServerCertificateRequestServerCertificateUpdateTypeDef",
    {
        "NewPath": str,
        "NewServerCertificateName": str,
    },
    total=False,
)

_RequiredUpdateServiceSpecificCredentialRequestRequestTypeDef = TypedDict(
    "_RequiredUpdateServiceSpecificCredentialRequestRequestTypeDef",
    {
        "ServiceSpecificCredentialId": str,
        "Status": statusTypeType,
    },
)
_OptionalUpdateServiceSpecificCredentialRequestRequestTypeDef = TypedDict(
    "_OptionalUpdateServiceSpecificCredentialRequestRequestTypeDef",
    {
        "UserName": str,
    },
    total=False,
)


class UpdateServiceSpecificCredentialRequestRequestTypeDef(
    _RequiredUpdateServiceSpecificCredentialRequestRequestTypeDef,
    _OptionalUpdateServiceSpecificCredentialRequestRequestTypeDef,
):
    pass


_RequiredUpdateSigningCertificateRequestRequestTypeDef = TypedDict(
    "_RequiredUpdateSigningCertificateRequestRequestTypeDef",
    {
        "CertificateId": str,
        "Status": statusTypeType,
    },
)
_OptionalUpdateSigningCertificateRequestRequestTypeDef = TypedDict(
    "_OptionalUpdateSigningCertificateRequestRequestTypeDef",
    {
        "UserName": str,
    },
    total=False,
)


class UpdateSigningCertificateRequestRequestTypeDef(
    _RequiredUpdateSigningCertificateRequestRequestTypeDef,
    _OptionalUpdateSigningCertificateRequestRequestTypeDef,
):
    pass


UpdateSigningCertificateRequestSigningCertificateActivateTypeDef = TypedDict(
    "UpdateSigningCertificateRequestSigningCertificateActivateTypeDef",
    {
        "Status": statusTypeType,
    },
    total=False,
)

UpdateSigningCertificateRequestSigningCertificateDeactivateTypeDef = TypedDict(
    "UpdateSigningCertificateRequestSigningCertificateDeactivateTypeDef",
    {
        "Status": statusTypeType,
    },
    total=False,
)

_RequiredUpdateUserRequestRequestTypeDef = TypedDict(
    "_RequiredUpdateUserRequestRequestTypeDef",
    {
        "UserName": str,
    },
)
_OptionalUpdateUserRequestRequestTypeDef = TypedDict(
    "_OptionalUpdateUserRequestRequestTypeDef",
    {
        "NewPath": str,
        "NewUserName": str,
    },
    total=False,
)


class UpdateUserRequestRequestTypeDef(
    _RequiredUpdateUserRequestRequestTypeDef, _OptionalUpdateUserRequestRequestTypeDef
):
    pass


UpdateUserRequestUserUpdateTypeDef = TypedDict(
    "UpdateUserRequestUserUpdateTypeDef",
    {
        "NewPath": str,
        "NewUserName": str,
    },
    total=False,
)

UploadSSHPublicKeyRequestRequestTypeDef = TypedDict(
    "UploadSSHPublicKeyRequestRequestTypeDef",
    {
        "UserName": str,
        "SSHPublicKeyBody": str,
    },
)

_RequiredUploadSigningCertificateRequestRequestTypeDef = TypedDict(
    "_RequiredUploadSigningCertificateRequestRequestTypeDef",
    {
        "CertificateBody": str,
    },
)
_OptionalUploadSigningCertificateRequestRequestTypeDef = TypedDict(
    "_OptionalUploadSigningCertificateRequestRequestTypeDef",
    {
        "UserName": str,
    },
    total=False,
)


class UploadSigningCertificateRequestRequestTypeDef(
    _RequiredUploadSigningCertificateRequestRequestTypeDef,
    _OptionalUploadSigningCertificateRequestRequestTypeDef,
):
    pass


_RequiredUploadSigningCertificateRequestServiceResourceCreateSigningCertificateTypeDef = TypedDict(
    "_RequiredUploadSigningCertificateRequestServiceResourceCreateSigningCertificateTypeDef",
    {
        "CertificateBody": str,
    },
)
_OptionalUploadSigningCertificateRequestServiceResourceCreateSigningCertificateTypeDef = TypedDict(
    "_OptionalUploadSigningCertificateRequestServiceResourceCreateSigningCertificateTypeDef",
    {
        "UserName": str,
    },
    total=False,
)


class UploadSigningCertificateRequestServiceResourceCreateSigningCertificateTypeDef(
    _RequiredUploadSigningCertificateRequestServiceResourceCreateSigningCertificateTypeDef,
    _OptionalUploadSigningCertificateRequestServiceResourceCreateSigningCertificateTypeDef,
):
    pass


GetAccessKeyLastUsedResponseOutputTypeDef = TypedDict(
    "GetAccessKeyLastUsedResponseOutputTypeDef",
    {
        "UserName": str,
        "AccessKeyLastUsed": AccessKeyLastUsedOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListAccessKeysResponseOutputTypeDef = TypedDict(
    "ListAccessKeysResponseOutputTypeDef",
    {
        "AccessKeyMetadata": List[AccessKeyMetadataOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateAccessKeyResponseOutputTypeDef = TypedDict(
    "CreateAccessKeyResponseOutputTypeDef",
    {
        "AccessKey": AccessKeyOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListAttachedGroupPoliciesResponseOutputTypeDef = TypedDict(
    "ListAttachedGroupPoliciesResponseOutputTypeDef",
    {
        "AttachedPolicies": List[AttachedPolicyOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListAttachedRolePoliciesResponseOutputTypeDef = TypedDict(
    "ListAttachedRolePoliciesResponseOutputTypeDef",
    {
        "AttachedPolicies": List[AttachedPolicyOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListAttachedUserPoliciesResponseOutputTypeDef = TypedDict(
    "ListAttachedUserPoliciesResponseOutputTypeDef",
    {
        "AttachedPolicies": List[AttachedPolicyOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredSimulateCustomPolicyRequestRequestTypeDef = TypedDict(
    "_RequiredSimulateCustomPolicyRequestRequestTypeDef",
    {
        "PolicyInputList": Sequence[str],
        "ActionNames": Sequence[str],
    },
)
_OptionalSimulateCustomPolicyRequestRequestTypeDef = TypedDict(
    "_OptionalSimulateCustomPolicyRequestRequestTypeDef",
    {
        "PermissionsBoundaryPolicyInputList": Sequence[str],
        "ResourceArns": Sequence[str],
        "ResourcePolicy": str,
        "ResourceOwner": str,
        "CallerArn": str,
        "ContextEntries": Sequence[ContextEntryTypeDef],
        "ResourceHandlingOption": str,
        "MaxItems": int,
        "Marker": str,
    },
    total=False,
)


class SimulateCustomPolicyRequestRequestTypeDef(
    _RequiredSimulateCustomPolicyRequestRequestTypeDef,
    _OptionalSimulateCustomPolicyRequestRequestTypeDef,
):
    pass


_RequiredSimulateCustomPolicyRequestSimulateCustomPolicyPaginateTypeDef = TypedDict(
    "_RequiredSimulateCustomPolicyRequestSimulateCustomPolicyPaginateTypeDef",
    {
        "PolicyInputList": Sequence[str],
        "ActionNames": Sequence[str],
    },
)
_OptionalSimulateCustomPolicyRequestSimulateCustomPolicyPaginateTypeDef = TypedDict(
    "_OptionalSimulateCustomPolicyRequestSimulateCustomPolicyPaginateTypeDef",
    {
        "PermissionsBoundaryPolicyInputList": Sequence[str],
        "ResourceArns": Sequence[str],
        "ResourcePolicy": str,
        "ResourceOwner": str,
        "CallerArn": str,
        "ContextEntries": Sequence[ContextEntryTypeDef],
        "ResourceHandlingOption": str,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class SimulateCustomPolicyRequestSimulateCustomPolicyPaginateTypeDef(
    _RequiredSimulateCustomPolicyRequestSimulateCustomPolicyPaginateTypeDef,
    _OptionalSimulateCustomPolicyRequestSimulateCustomPolicyPaginateTypeDef,
):
    pass


_RequiredSimulatePrincipalPolicyRequestRequestTypeDef = TypedDict(
    "_RequiredSimulatePrincipalPolicyRequestRequestTypeDef",
    {
        "PolicySourceArn": str,
        "ActionNames": Sequence[str],
    },
)
_OptionalSimulatePrincipalPolicyRequestRequestTypeDef = TypedDict(
    "_OptionalSimulatePrincipalPolicyRequestRequestTypeDef",
    {
        "PolicyInputList": Sequence[str],
        "PermissionsBoundaryPolicyInputList": Sequence[str],
        "ResourceArns": Sequence[str],
        "ResourcePolicy": str,
        "ResourceOwner": str,
        "CallerArn": str,
        "ContextEntries": Sequence[ContextEntryTypeDef],
        "ResourceHandlingOption": str,
        "MaxItems": int,
        "Marker": str,
    },
    total=False,
)


class SimulatePrincipalPolicyRequestRequestTypeDef(
    _RequiredSimulatePrincipalPolicyRequestRequestTypeDef,
    _OptionalSimulatePrincipalPolicyRequestRequestTypeDef,
):
    pass


_RequiredSimulatePrincipalPolicyRequestSimulatePrincipalPolicyPaginateTypeDef = TypedDict(
    "_RequiredSimulatePrincipalPolicyRequestSimulatePrincipalPolicyPaginateTypeDef",
    {
        "PolicySourceArn": str,
        "ActionNames": Sequence[str],
    },
)
_OptionalSimulatePrincipalPolicyRequestSimulatePrincipalPolicyPaginateTypeDef = TypedDict(
    "_OptionalSimulatePrincipalPolicyRequestSimulatePrincipalPolicyPaginateTypeDef",
    {
        "PolicyInputList": Sequence[str],
        "PermissionsBoundaryPolicyInputList": Sequence[str],
        "ResourceArns": Sequence[str],
        "ResourcePolicy": str,
        "ResourceOwner": str,
        "CallerArn": str,
        "ContextEntries": Sequence[ContextEntryTypeDef],
        "ResourceHandlingOption": str,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class SimulatePrincipalPolicyRequestSimulatePrincipalPolicyPaginateTypeDef(
    _RequiredSimulatePrincipalPolicyRequestSimulatePrincipalPolicyPaginateTypeDef,
    _OptionalSimulatePrincipalPolicyRequestSimulatePrincipalPolicyPaginateTypeDef,
):
    pass


CreateGroupResponseOutputTypeDef = TypedDict(
    "CreateGroupResponseOutputTypeDef",
    {
        "Group": GroupOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListGroupsForUserResponseOutputTypeDef = TypedDict(
    "ListGroupsForUserResponseOutputTypeDef",
    {
        "Groups": List[GroupOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListGroupsResponseOutputTypeDef = TypedDict(
    "ListGroupsResponseOutputTypeDef",
    {
        "Groups": List[GroupOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredCreateInstanceProfileRequestRequestTypeDef = TypedDict(
    "_RequiredCreateInstanceProfileRequestRequestTypeDef",
    {
        "InstanceProfileName": str,
    },
)
_OptionalCreateInstanceProfileRequestRequestTypeDef = TypedDict(
    "_OptionalCreateInstanceProfileRequestRequestTypeDef",
    {
        "Path": str,
        "Tags": Sequence[TagTypeDef],
    },
    total=False,
)


class CreateInstanceProfileRequestRequestTypeDef(
    _RequiredCreateInstanceProfileRequestRequestTypeDef,
    _OptionalCreateInstanceProfileRequestRequestTypeDef,
):
    pass


_RequiredCreateInstanceProfileRequestServiceResourceCreateInstanceProfileTypeDef = TypedDict(
    "_RequiredCreateInstanceProfileRequestServiceResourceCreateInstanceProfileTypeDef",
    {
        "InstanceProfileName": str,
    },
)
_OptionalCreateInstanceProfileRequestServiceResourceCreateInstanceProfileTypeDef = TypedDict(
    "_OptionalCreateInstanceProfileRequestServiceResourceCreateInstanceProfileTypeDef",
    {
        "Path": str,
        "Tags": Sequence[TagTypeDef],
    },
    total=False,
)


class CreateInstanceProfileRequestServiceResourceCreateInstanceProfileTypeDef(
    _RequiredCreateInstanceProfileRequestServiceResourceCreateInstanceProfileTypeDef,
    _OptionalCreateInstanceProfileRequestServiceResourceCreateInstanceProfileTypeDef,
):
    pass


_RequiredCreateOpenIDConnectProviderRequestRequestTypeDef = TypedDict(
    "_RequiredCreateOpenIDConnectProviderRequestRequestTypeDef",
    {
        "Url": str,
        "ThumbprintList": Sequence[str],
    },
)
_OptionalCreateOpenIDConnectProviderRequestRequestTypeDef = TypedDict(
    "_OptionalCreateOpenIDConnectProviderRequestRequestTypeDef",
    {
        "ClientIDList": Sequence[str],
        "Tags": Sequence[TagTypeDef],
    },
    total=False,
)


class CreateOpenIDConnectProviderRequestRequestTypeDef(
    _RequiredCreateOpenIDConnectProviderRequestRequestTypeDef,
    _OptionalCreateOpenIDConnectProviderRequestRequestTypeDef,
):
    pass


_RequiredCreatePolicyRequestRequestTypeDef = TypedDict(
    "_RequiredCreatePolicyRequestRequestTypeDef",
    {
        "PolicyName": str,
        "PolicyDocument": str,
    },
)
_OptionalCreatePolicyRequestRequestTypeDef = TypedDict(
    "_OptionalCreatePolicyRequestRequestTypeDef",
    {
        "Path": str,
        "Description": str,
        "Tags": Sequence[TagTypeDef],
    },
    total=False,
)


class CreatePolicyRequestRequestTypeDef(
    _RequiredCreatePolicyRequestRequestTypeDef, _OptionalCreatePolicyRequestRequestTypeDef
):
    pass


_RequiredCreatePolicyRequestServiceResourceCreatePolicyTypeDef = TypedDict(
    "_RequiredCreatePolicyRequestServiceResourceCreatePolicyTypeDef",
    {
        "PolicyName": str,
        "PolicyDocument": str,
    },
)
_OptionalCreatePolicyRequestServiceResourceCreatePolicyTypeDef = TypedDict(
    "_OptionalCreatePolicyRequestServiceResourceCreatePolicyTypeDef",
    {
        "Path": str,
        "Description": str,
        "Tags": Sequence[TagTypeDef],
    },
    total=False,
)


class CreatePolicyRequestServiceResourceCreatePolicyTypeDef(
    _RequiredCreatePolicyRequestServiceResourceCreatePolicyTypeDef,
    _OptionalCreatePolicyRequestServiceResourceCreatePolicyTypeDef,
):
    pass


_RequiredCreateRoleRequestRequestTypeDef = TypedDict(
    "_RequiredCreateRoleRequestRequestTypeDef",
    {
        "RoleName": str,
        "AssumeRolePolicyDocument": str,
    },
)
_OptionalCreateRoleRequestRequestTypeDef = TypedDict(
    "_OptionalCreateRoleRequestRequestTypeDef",
    {
        "Path": str,
        "Description": str,
        "MaxSessionDuration": int,
        "PermissionsBoundary": str,
        "Tags": Sequence[TagTypeDef],
    },
    total=False,
)


class CreateRoleRequestRequestTypeDef(
    _RequiredCreateRoleRequestRequestTypeDef, _OptionalCreateRoleRequestRequestTypeDef
):
    pass


_RequiredCreateRoleRequestServiceResourceCreateRoleTypeDef = TypedDict(
    "_RequiredCreateRoleRequestServiceResourceCreateRoleTypeDef",
    {
        "RoleName": str,
        "AssumeRolePolicyDocument": str,
    },
)
_OptionalCreateRoleRequestServiceResourceCreateRoleTypeDef = TypedDict(
    "_OptionalCreateRoleRequestServiceResourceCreateRoleTypeDef",
    {
        "Path": str,
        "Description": str,
        "MaxSessionDuration": int,
        "PermissionsBoundary": str,
        "Tags": Sequence[TagTypeDef],
    },
    total=False,
)


class CreateRoleRequestServiceResourceCreateRoleTypeDef(
    _RequiredCreateRoleRequestServiceResourceCreateRoleTypeDef,
    _OptionalCreateRoleRequestServiceResourceCreateRoleTypeDef,
):
    pass


_RequiredCreateSAMLProviderRequestRequestTypeDef = TypedDict(
    "_RequiredCreateSAMLProviderRequestRequestTypeDef",
    {
        "SAMLMetadataDocument": str,
        "Name": str,
    },
)
_OptionalCreateSAMLProviderRequestRequestTypeDef = TypedDict(
    "_OptionalCreateSAMLProviderRequestRequestTypeDef",
    {
        "Tags": Sequence[TagTypeDef],
    },
    total=False,
)


class CreateSAMLProviderRequestRequestTypeDef(
    _RequiredCreateSAMLProviderRequestRequestTypeDef,
    _OptionalCreateSAMLProviderRequestRequestTypeDef,
):
    pass


_RequiredCreateSAMLProviderRequestServiceResourceCreateSamlProviderTypeDef = TypedDict(
    "_RequiredCreateSAMLProviderRequestServiceResourceCreateSamlProviderTypeDef",
    {
        "SAMLMetadataDocument": str,
        "Name": str,
    },
)
_OptionalCreateSAMLProviderRequestServiceResourceCreateSamlProviderTypeDef = TypedDict(
    "_OptionalCreateSAMLProviderRequestServiceResourceCreateSamlProviderTypeDef",
    {
        "Tags": Sequence[TagTypeDef],
    },
    total=False,
)


class CreateSAMLProviderRequestServiceResourceCreateSamlProviderTypeDef(
    _RequiredCreateSAMLProviderRequestServiceResourceCreateSamlProviderTypeDef,
    _OptionalCreateSAMLProviderRequestServiceResourceCreateSamlProviderTypeDef,
):
    pass


_RequiredCreateUserRequestRequestTypeDef = TypedDict(
    "_RequiredCreateUserRequestRequestTypeDef",
    {
        "UserName": str,
    },
)
_OptionalCreateUserRequestRequestTypeDef = TypedDict(
    "_OptionalCreateUserRequestRequestTypeDef",
    {
        "Path": str,
        "PermissionsBoundary": str,
        "Tags": Sequence[TagTypeDef],
    },
    total=False,
)


class CreateUserRequestRequestTypeDef(
    _RequiredCreateUserRequestRequestTypeDef, _OptionalCreateUserRequestRequestTypeDef
):
    pass


_RequiredCreateUserRequestServiceResourceCreateUserTypeDef = TypedDict(
    "_RequiredCreateUserRequestServiceResourceCreateUserTypeDef",
    {
        "UserName": str,
    },
)
_OptionalCreateUserRequestServiceResourceCreateUserTypeDef = TypedDict(
    "_OptionalCreateUserRequestServiceResourceCreateUserTypeDef",
    {
        "Path": str,
        "PermissionsBoundary": str,
        "Tags": Sequence[TagTypeDef],
    },
    total=False,
)


class CreateUserRequestServiceResourceCreateUserTypeDef(
    _RequiredCreateUserRequestServiceResourceCreateUserTypeDef,
    _OptionalCreateUserRequestServiceResourceCreateUserTypeDef,
):
    pass


CreateUserRequestUserCreateTypeDef = TypedDict(
    "CreateUserRequestUserCreateTypeDef",
    {
        "Path": str,
        "PermissionsBoundary": str,
        "Tags": Sequence[TagTypeDef],
    },
    total=False,
)

_RequiredCreateVirtualMFADeviceRequestRequestTypeDef = TypedDict(
    "_RequiredCreateVirtualMFADeviceRequestRequestTypeDef",
    {
        "VirtualMFADeviceName": str,
    },
)
_OptionalCreateVirtualMFADeviceRequestRequestTypeDef = TypedDict(
    "_OptionalCreateVirtualMFADeviceRequestRequestTypeDef",
    {
        "Path": str,
        "Tags": Sequence[TagTypeDef],
    },
    total=False,
)


class CreateVirtualMFADeviceRequestRequestTypeDef(
    _RequiredCreateVirtualMFADeviceRequestRequestTypeDef,
    _OptionalCreateVirtualMFADeviceRequestRequestTypeDef,
):
    pass


_RequiredCreateVirtualMFADeviceRequestServiceResourceCreateVirtualMfaDeviceTypeDef = TypedDict(
    "_RequiredCreateVirtualMFADeviceRequestServiceResourceCreateVirtualMfaDeviceTypeDef",
    {
        "VirtualMFADeviceName": str,
    },
)
_OptionalCreateVirtualMFADeviceRequestServiceResourceCreateVirtualMfaDeviceTypeDef = TypedDict(
    "_OptionalCreateVirtualMFADeviceRequestServiceResourceCreateVirtualMfaDeviceTypeDef",
    {
        "Path": str,
        "Tags": Sequence[TagTypeDef],
    },
    total=False,
)


class CreateVirtualMFADeviceRequestServiceResourceCreateVirtualMfaDeviceTypeDef(
    _RequiredCreateVirtualMFADeviceRequestServiceResourceCreateVirtualMfaDeviceTypeDef,
    _OptionalCreateVirtualMFADeviceRequestServiceResourceCreateVirtualMfaDeviceTypeDef,
):
    pass


TagInstanceProfileRequestRequestTypeDef = TypedDict(
    "TagInstanceProfileRequestRequestTypeDef",
    {
        "InstanceProfileName": str,
        "Tags": Sequence[TagTypeDef],
    },
)

TagMFADeviceRequestRequestTypeDef = TypedDict(
    "TagMFADeviceRequestRequestTypeDef",
    {
        "SerialNumber": str,
        "Tags": Sequence[TagTypeDef],
    },
)

TagOpenIDConnectProviderRequestRequestTypeDef = TypedDict(
    "TagOpenIDConnectProviderRequestRequestTypeDef",
    {
        "OpenIDConnectProviderArn": str,
        "Tags": Sequence[TagTypeDef],
    },
)

TagPolicyRequestRequestTypeDef = TypedDict(
    "TagPolicyRequestRequestTypeDef",
    {
        "PolicyArn": str,
        "Tags": Sequence[TagTypeDef],
    },
)

TagRoleRequestRequestTypeDef = TypedDict(
    "TagRoleRequestRequestTypeDef",
    {
        "RoleName": str,
        "Tags": Sequence[TagTypeDef],
    },
)

TagSAMLProviderRequestRequestTypeDef = TypedDict(
    "TagSAMLProviderRequestRequestTypeDef",
    {
        "SAMLProviderArn": str,
        "Tags": Sequence[TagTypeDef],
    },
)

TagServerCertificateRequestRequestTypeDef = TypedDict(
    "TagServerCertificateRequestRequestTypeDef",
    {
        "ServerCertificateName": str,
        "Tags": Sequence[TagTypeDef],
    },
)

TagUserRequestRequestTypeDef = TypedDict(
    "TagUserRequestRequestTypeDef",
    {
        "UserName": str,
        "Tags": Sequence[TagTypeDef],
    },
)

_RequiredUploadServerCertificateRequestRequestTypeDef = TypedDict(
    "_RequiredUploadServerCertificateRequestRequestTypeDef",
    {
        "ServerCertificateName": str,
        "CertificateBody": str,
        "PrivateKey": str,
    },
)
_OptionalUploadServerCertificateRequestRequestTypeDef = TypedDict(
    "_OptionalUploadServerCertificateRequestRequestTypeDef",
    {
        "Path": str,
        "CertificateChain": str,
        "Tags": Sequence[TagTypeDef],
    },
    total=False,
)


class UploadServerCertificateRequestRequestTypeDef(
    _RequiredUploadServerCertificateRequestRequestTypeDef,
    _OptionalUploadServerCertificateRequestRequestTypeDef,
):
    pass


_RequiredUploadServerCertificateRequestServiceResourceCreateServerCertificateTypeDef = TypedDict(
    "_RequiredUploadServerCertificateRequestServiceResourceCreateServerCertificateTypeDef",
    {
        "ServerCertificateName": str,
        "CertificateBody": str,
        "PrivateKey": str,
    },
)
_OptionalUploadServerCertificateRequestServiceResourceCreateServerCertificateTypeDef = TypedDict(
    "_OptionalUploadServerCertificateRequestServiceResourceCreateServerCertificateTypeDef",
    {
        "Path": str,
        "CertificateChain": str,
        "Tags": Sequence[TagTypeDef],
    },
    total=False,
)


class UploadServerCertificateRequestServiceResourceCreateServerCertificateTypeDef(
    _RequiredUploadServerCertificateRequestServiceResourceCreateServerCertificateTypeDef,
    _OptionalUploadServerCertificateRequestServiceResourceCreateServerCertificateTypeDef,
):
    pass


CreateLoginProfileResponseOutputTypeDef = TypedDict(
    "CreateLoginProfileResponseOutputTypeDef",
    {
        "LoginProfile": LoginProfileOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetLoginProfileResponseOutputTypeDef = TypedDict(
    "GetLoginProfileResponseOutputTypeDef",
    {
        "LoginProfile": LoginProfileOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateOpenIDConnectProviderResponseOutputTypeDef = TypedDict(
    "CreateOpenIDConnectProviderResponseOutputTypeDef",
    {
        "OpenIDConnectProviderArn": str,
        "Tags": List[TagOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateSAMLProviderResponseOutputTypeDef = TypedDict(
    "CreateSAMLProviderResponseOutputTypeDef",
    {
        "SAMLProviderArn": str,
        "Tags": List[TagOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetOpenIDConnectProviderResponseOutputTypeDef = TypedDict(
    "GetOpenIDConnectProviderResponseOutputTypeDef",
    {
        "Url": str,
        "ClientIDList": List[str],
        "ThumbprintList": List[str],
        "CreateDate": datetime,
        "Tags": List[TagOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetSAMLProviderResponseOutputTypeDef = TypedDict(
    "GetSAMLProviderResponseOutputTypeDef",
    {
        "SAMLMetadataDocument": str,
        "CreateDate": datetime,
        "ValidUntil": datetime,
        "Tags": List[TagOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListInstanceProfileTagsResponseOutputTypeDef = TypedDict(
    "ListInstanceProfileTagsResponseOutputTypeDef",
    {
        "Tags": List[TagOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListMFADeviceTagsResponseOutputTypeDef = TypedDict(
    "ListMFADeviceTagsResponseOutputTypeDef",
    {
        "Tags": List[TagOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListOpenIDConnectProviderTagsResponseOutputTypeDef = TypedDict(
    "ListOpenIDConnectProviderTagsResponseOutputTypeDef",
    {
        "Tags": List[TagOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListPolicyTagsResponseOutputTypeDef = TypedDict(
    "ListPolicyTagsResponseOutputTypeDef",
    {
        "Tags": List[TagOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListRoleTagsResponseOutputTypeDef = TypedDict(
    "ListRoleTagsResponseOutputTypeDef",
    {
        "Tags": List[TagOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListSAMLProviderTagsResponseOutputTypeDef = TypedDict(
    "ListSAMLProviderTagsResponseOutputTypeDef",
    {
        "Tags": List[TagOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListServerCertificateTagsResponseOutputTypeDef = TypedDict(
    "ListServerCertificateTagsResponseOutputTypeDef",
    {
        "Tags": List[TagOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListUserTagsResponseOutputTypeDef = TypedDict(
    "ListUserTagsResponseOutputTypeDef",
    {
        "Tags": List[TagOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

PolicyOutputTypeDef = TypedDict(
    "PolicyOutputTypeDef",
    {
        "PolicyName": str,
        "PolicyId": str,
        "Arn": str,
        "Path": str,
        "DefaultVersionId": str,
        "AttachmentCount": int,
        "PermissionsBoundaryUsageCount": int,
        "IsAttachable": bool,
        "Description": str,
        "CreateDate": datetime,
        "UpdateDate": datetime,
        "Tags": List[TagOutputTypeDef],
    },
)

UserOutputTypeDef = TypedDict(
    "UserOutputTypeDef",
    {
        "Path": str,
        "UserName": str,
        "UserId": str,
        "Arn": str,
        "CreateDate": datetime,
        "PasswordLastUsed": datetime,
        "PermissionsBoundary": AttachedPermissionsBoundaryOutputTypeDef,
        "Tags": List[TagOutputTypeDef],
    },
)

UserResponseMetadataTypeDef = TypedDict(
    "UserResponseMetadataTypeDef",
    {
        "Path": str,
        "UserName": str,
        "UserId": str,
        "Arn": str,
        "CreateDate": datetime,
        "PasswordLastUsed": datetime,
        "PermissionsBoundary": AttachedPermissionsBoundaryOutputTypeDef,
        "Tags": List[TagOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreatePolicyVersionResponseOutputTypeDef = TypedDict(
    "CreatePolicyVersionResponseOutputTypeDef",
    {
        "PolicyVersion": PolicyVersionOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetPolicyVersionResponseOutputTypeDef = TypedDict(
    "GetPolicyVersionResponseOutputTypeDef",
    {
        "PolicyVersion": PolicyVersionOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListPolicyVersionsResponseOutputTypeDef = TypedDict(
    "ListPolicyVersionsResponseOutputTypeDef",
    {
        "Versions": List[PolicyVersionOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ManagedPolicyDetailOutputTypeDef = TypedDict(
    "ManagedPolicyDetailOutputTypeDef",
    {
        "PolicyName": str,
        "PolicyId": str,
        "Arn": str,
        "Path": str,
        "DefaultVersionId": str,
        "AttachmentCount": int,
        "PermissionsBoundaryUsageCount": int,
        "IsAttachable": bool,
        "Description": str,
        "CreateDate": datetime,
        "UpdateDate": datetime,
        "PolicyVersionList": List[PolicyVersionOutputTypeDef],
    },
)

CreateServiceSpecificCredentialResponseOutputTypeDef = TypedDict(
    "CreateServiceSpecificCredentialResponseOutputTypeDef",
    {
        "ServiceSpecificCredential": ServiceSpecificCredentialOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ResetServiceSpecificCredentialResponseOutputTypeDef = TypedDict(
    "ResetServiceSpecificCredentialResponseOutputTypeDef",
    {
        "ServiceSpecificCredential": ServiceSpecificCredentialOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeletionTaskFailureReasonTypeOutputTypeDef = TypedDict(
    "DeletionTaskFailureReasonTypeOutputTypeDef",
    {
        "Reason": str,
        "RoleUsageList": List[RoleUsageTypeOutputTypeDef],
    },
)

EntityDetailsOutputTypeDef = TypedDict(
    "EntityDetailsOutputTypeDef",
    {
        "EntityInfo": EntityInfoOutputTypeDef,
        "LastAuthenticated": datetime,
    },
)

GetOrganizationsAccessReportResponseOutputTypeDef = TypedDict(
    "GetOrganizationsAccessReportResponseOutputTypeDef",
    {
        "JobStatus": jobStatusTypeType,
        "JobCreationDate": datetime,
        "JobCompletionDate": datetime,
        "NumberOfServicesAccessible": int,
        "NumberOfServicesNotAccessed": int,
        "AccessDetails": List[AccessDetailOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ErrorDetails": ErrorDetailsOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetAccountPasswordPolicyResponseOutputTypeDef = TypedDict(
    "GetAccountPasswordPolicyResponseOutputTypeDef",
    {
        "PasswordPolicy": PasswordPolicyOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredGetInstanceProfileRequestInstanceProfileExistsWaitTypeDef = TypedDict(
    "_RequiredGetInstanceProfileRequestInstanceProfileExistsWaitTypeDef",
    {
        "InstanceProfileName": str,
    },
)
_OptionalGetInstanceProfileRequestInstanceProfileExistsWaitTypeDef = TypedDict(
    "_OptionalGetInstanceProfileRequestInstanceProfileExistsWaitTypeDef",
    {
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)


class GetInstanceProfileRequestInstanceProfileExistsWaitTypeDef(
    _RequiredGetInstanceProfileRequestInstanceProfileExistsWaitTypeDef,
    _OptionalGetInstanceProfileRequestInstanceProfileExistsWaitTypeDef,
):
    pass


_RequiredGetPolicyRequestPolicyExistsWaitTypeDef = TypedDict(
    "_RequiredGetPolicyRequestPolicyExistsWaitTypeDef",
    {
        "PolicyArn": str,
    },
)
_OptionalGetPolicyRequestPolicyExistsWaitTypeDef = TypedDict(
    "_OptionalGetPolicyRequestPolicyExistsWaitTypeDef",
    {
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)


class GetPolicyRequestPolicyExistsWaitTypeDef(
    _RequiredGetPolicyRequestPolicyExistsWaitTypeDef,
    _OptionalGetPolicyRequestPolicyExistsWaitTypeDef,
):
    pass


_RequiredGetRoleRequestRoleExistsWaitTypeDef = TypedDict(
    "_RequiredGetRoleRequestRoleExistsWaitTypeDef",
    {
        "RoleName": str,
    },
)
_OptionalGetRoleRequestRoleExistsWaitTypeDef = TypedDict(
    "_OptionalGetRoleRequestRoleExistsWaitTypeDef",
    {
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)


class GetRoleRequestRoleExistsWaitTypeDef(
    _RequiredGetRoleRequestRoleExistsWaitTypeDef, _OptionalGetRoleRequestRoleExistsWaitTypeDef
):
    pass


GetUserRequestUserExistsWaitTypeDef = TypedDict(
    "GetUserRequestUserExistsWaitTypeDef",
    {
        "UserName": str,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

GetSSHPublicKeyResponseOutputTypeDef = TypedDict(
    "GetSSHPublicKeyResponseOutputTypeDef",
    {
        "SSHPublicKey": SSHPublicKeyOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

UploadSSHPublicKeyResponseOutputTypeDef = TypedDict(
    "UploadSSHPublicKeyResponseOutputTypeDef",
    {
        "SSHPublicKey": SSHPublicKeyOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GroupDetailOutputTypeDef = TypedDict(
    "GroupDetailOutputTypeDef",
    {
        "Path": str,
        "GroupName": str,
        "GroupId": str,
        "Arn": str,
        "CreateDate": datetime,
        "GroupPolicyList": List[PolicyDetailOutputTypeDef],
        "AttachedManagedPolicies": List[AttachedPolicyOutputTypeDef],
    },
)

UserDetailOutputTypeDef = TypedDict(
    "UserDetailOutputTypeDef",
    {
        "Path": str,
        "UserName": str,
        "UserId": str,
        "Arn": str,
        "CreateDate": datetime,
        "UserPolicyList": List[PolicyDetailOutputTypeDef],
        "GroupList": List[str],
        "AttachedManagedPolicies": List[AttachedPolicyOutputTypeDef],
        "PermissionsBoundary": AttachedPermissionsBoundaryOutputTypeDef,
        "Tags": List[TagOutputTypeDef],
    },
)

ListEntitiesForPolicyResponseOutputTypeDef = TypedDict(
    "ListEntitiesForPolicyResponseOutputTypeDef",
    {
        "PolicyGroups": List[PolicyGroupOutputTypeDef],
        "PolicyUsers": List[PolicyUserOutputTypeDef],
        "PolicyRoles": List[PolicyRoleOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListMFADevicesResponseOutputTypeDef = TypedDict(
    "ListMFADevicesResponseOutputTypeDef",
    {
        "MFADevices": List[MFADeviceOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListOpenIDConnectProvidersResponseOutputTypeDef = TypedDict(
    "ListOpenIDConnectProvidersResponseOutputTypeDef",
    {
        "OpenIDConnectProviderList": List[OpenIDConnectProviderListEntryOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListPoliciesGrantingServiceAccessEntryOutputTypeDef = TypedDict(
    "ListPoliciesGrantingServiceAccessEntryOutputTypeDef",
    {
        "ServiceNamespace": str,
        "Policies": List[PolicyGrantingServiceAccessOutputTypeDef],
    },
)

ListSAMLProvidersResponseOutputTypeDef = TypedDict(
    "ListSAMLProvidersResponseOutputTypeDef",
    {
        "SAMLProviderList": List[SAMLProviderListEntryOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListSSHPublicKeysResponseOutputTypeDef = TypedDict(
    "ListSSHPublicKeysResponseOutputTypeDef",
    {
        "SSHPublicKeys": List[SSHPublicKeyMetadataOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListServerCertificatesResponseOutputTypeDef = TypedDict(
    "ListServerCertificatesResponseOutputTypeDef",
    {
        "ServerCertificateMetadataList": List[ServerCertificateMetadataOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ServerCertificateOutputTypeDef = TypedDict(
    "ServerCertificateOutputTypeDef",
    {
        "ServerCertificateMetadata": ServerCertificateMetadataOutputTypeDef,
        "CertificateBody": str,
        "CertificateChain": str,
        "Tags": List[TagOutputTypeDef],
    },
)

UploadServerCertificateResponseOutputTypeDef = TypedDict(
    "UploadServerCertificateResponseOutputTypeDef",
    {
        "ServerCertificateMetadata": ServerCertificateMetadataOutputTypeDef,
        "Tags": List[TagOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListServiceSpecificCredentialsResponseOutputTypeDef = TypedDict(
    "ListServiceSpecificCredentialsResponseOutputTypeDef",
    {
        "ServiceSpecificCredentials": List[ServiceSpecificCredentialMetadataOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListSigningCertificatesResponseOutputTypeDef = TypedDict(
    "ListSigningCertificatesResponseOutputTypeDef",
    {
        "Certificates": List[SigningCertificateOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

UploadSigningCertificateResponseOutputTypeDef = TypedDict(
    "UploadSigningCertificateResponseOutputTypeDef",
    {
        "Certificate": SigningCertificateOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

StatementOutputTypeDef = TypedDict(
    "StatementOutputTypeDef",
    {
        "SourcePolicyId": str,
        "SourcePolicyType": PolicySourceTypeType,
        "StartPosition": PositionOutputTypeDef,
        "EndPosition": PositionOutputTypeDef,
    },
)

RoleOutputTypeDef = TypedDict(
    "RoleOutputTypeDef",
    {
        "Path": str,
        "RoleName": str,
        "RoleId": str,
        "Arn": str,
        "CreateDate": datetime,
        "AssumeRolePolicyDocument": str,
        "Description": str,
        "MaxSessionDuration": int,
        "PermissionsBoundary": AttachedPermissionsBoundaryOutputTypeDef,
        "Tags": List[TagOutputTypeDef],
        "RoleLastUsed": RoleLastUsedOutputTypeDef,
    },
)

ServiceLastAccessedOutputTypeDef = TypedDict(
    "ServiceLastAccessedOutputTypeDef",
    {
        "ServiceName": str,
        "LastAuthenticated": datetime,
        "ServiceNamespace": str,
        "LastAuthenticatedEntity": str,
        "LastAuthenticatedRegion": str,
        "TotalAuthenticatedEntities": int,
        "TrackedActionsLastAccessed": List[TrackedActionLastAccessedOutputTypeDef],
    },
)

CreatePolicyResponseOutputTypeDef = TypedDict(
    "CreatePolicyResponseOutputTypeDef",
    {
        "Policy": PolicyOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetPolicyResponseOutputTypeDef = TypedDict(
    "GetPolicyResponseOutputTypeDef",
    {
        "Policy": PolicyOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListPoliciesResponseOutputTypeDef = TypedDict(
    "ListPoliciesResponseOutputTypeDef",
    {
        "Policies": List[PolicyOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateUserResponseOutputTypeDef = TypedDict(
    "CreateUserResponseOutputTypeDef",
    {
        "User": UserOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetGroupResponseOutputTypeDef = TypedDict(
    "GetGroupResponseOutputTypeDef",
    {
        "Group": GroupOutputTypeDef,
        "Users": List[UserOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetUserResponseOutputTypeDef = TypedDict(
    "GetUserResponseOutputTypeDef",
    {
        "User": UserOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListUsersResponseOutputTypeDef = TypedDict(
    "ListUsersResponseOutputTypeDef",
    {
        "Users": List[UserOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

VirtualMFADeviceOutputTypeDef = TypedDict(
    "VirtualMFADeviceOutputTypeDef",
    {
        "SerialNumber": str,
        "Base32StringSeed": bytes,
        "QRCodePNG": bytes,
        "User": UserOutputTypeDef,
        "EnableDate": datetime,
        "Tags": List[TagOutputTypeDef],
    },
)

GetServiceLinkedRoleDeletionStatusResponseOutputTypeDef = TypedDict(
    "GetServiceLinkedRoleDeletionStatusResponseOutputTypeDef",
    {
        "Status": DeletionTaskStatusTypeType,
        "Reason": DeletionTaskFailureReasonTypeOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetServiceLastAccessedDetailsWithEntitiesResponseOutputTypeDef = TypedDict(
    "GetServiceLastAccessedDetailsWithEntitiesResponseOutputTypeDef",
    {
        "JobStatus": jobStatusTypeType,
        "JobCreationDate": datetime,
        "JobCompletionDate": datetime,
        "EntityDetailsList": List[EntityDetailsOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "Error": ErrorDetailsOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListPoliciesGrantingServiceAccessResponseOutputTypeDef = TypedDict(
    "ListPoliciesGrantingServiceAccessResponseOutputTypeDef",
    {
        "PoliciesGrantingServiceAccess": List[ListPoliciesGrantingServiceAccessEntryOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetServerCertificateResponseOutputTypeDef = TypedDict(
    "GetServerCertificateResponseOutputTypeDef",
    {
        "ServerCertificate": ServerCertificateOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ResourceSpecificResultOutputTypeDef = TypedDict(
    "ResourceSpecificResultOutputTypeDef",
    {
        "EvalResourceName": str,
        "EvalResourceDecision": PolicyEvaluationDecisionTypeType,
        "MatchedStatements": List[StatementOutputTypeDef],
        "MissingContextValues": List[str],
        "EvalDecisionDetails": Dict[str, PolicyEvaluationDecisionTypeType],
        "PermissionsBoundaryDecisionDetail": PermissionsBoundaryDecisionDetailOutputTypeDef,
    },
)

CreateRoleResponseOutputTypeDef = TypedDict(
    "CreateRoleResponseOutputTypeDef",
    {
        "Role": RoleOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateServiceLinkedRoleResponseOutputTypeDef = TypedDict(
    "CreateServiceLinkedRoleResponseOutputTypeDef",
    {
        "Role": RoleOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetRoleResponseOutputTypeDef = TypedDict(
    "GetRoleResponseOutputTypeDef",
    {
        "Role": RoleOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

InstanceProfileOutputTypeDef = TypedDict(
    "InstanceProfileOutputTypeDef",
    {
        "Path": str,
        "InstanceProfileName": str,
        "InstanceProfileId": str,
        "Arn": str,
        "CreateDate": datetime,
        "Roles": List[RoleOutputTypeDef],
        "Tags": List[TagOutputTypeDef],
    },
)

ListRolesResponseOutputTypeDef = TypedDict(
    "ListRolesResponseOutputTypeDef",
    {
        "Roles": List[RoleOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

UpdateRoleDescriptionResponseOutputTypeDef = TypedDict(
    "UpdateRoleDescriptionResponseOutputTypeDef",
    {
        "Role": RoleOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetServiceLastAccessedDetailsResponseOutputTypeDef = TypedDict(
    "GetServiceLastAccessedDetailsResponseOutputTypeDef",
    {
        "JobStatus": jobStatusTypeType,
        "JobType": AccessAdvisorUsageGranularityTypeType,
        "JobCreationDate": datetime,
        "ServicesLastAccessed": List[ServiceLastAccessedOutputTypeDef],
        "JobCompletionDate": datetime,
        "IsTruncated": bool,
        "Marker": str,
        "Error": ErrorDetailsOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateVirtualMFADeviceResponseOutputTypeDef = TypedDict(
    "CreateVirtualMFADeviceResponseOutputTypeDef",
    {
        "VirtualMFADevice": VirtualMFADeviceOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListVirtualMFADevicesResponseOutputTypeDef = TypedDict(
    "ListVirtualMFADevicesResponseOutputTypeDef",
    {
        "VirtualMFADevices": List[VirtualMFADeviceOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

EvaluationResultOutputTypeDef = TypedDict(
    "EvaluationResultOutputTypeDef",
    {
        "EvalActionName": str,
        "EvalResourceName": str,
        "EvalDecision": PolicyEvaluationDecisionTypeType,
        "MatchedStatements": List[StatementOutputTypeDef],
        "MissingContextValues": List[str],
        "OrganizationsDecisionDetail": OrganizationsDecisionDetailOutputTypeDef,
        "PermissionsBoundaryDecisionDetail": PermissionsBoundaryDecisionDetailOutputTypeDef,
        "EvalDecisionDetails": Dict[str, PolicyEvaluationDecisionTypeType],
        "ResourceSpecificResults": List[ResourceSpecificResultOutputTypeDef],
    },
)

CreateInstanceProfileResponseOutputTypeDef = TypedDict(
    "CreateInstanceProfileResponseOutputTypeDef",
    {
        "InstanceProfile": InstanceProfileOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetInstanceProfileResponseOutputTypeDef = TypedDict(
    "GetInstanceProfileResponseOutputTypeDef",
    {
        "InstanceProfile": InstanceProfileOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListInstanceProfilesForRoleResponseOutputTypeDef = TypedDict(
    "ListInstanceProfilesForRoleResponseOutputTypeDef",
    {
        "InstanceProfiles": List[InstanceProfileOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ListInstanceProfilesResponseOutputTypeDef = TypedDict(
    "ListInstanceProfilesResponseOutputTypeDef",
    {
        "InstanceProfiles": List[InstanceProfileOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

RoleDetailOutputTypeDef = TypedDict(
    "RoleDetailOutputTypeDef",
    {
        "Path": str,
        "RoleName": str,
        "RoleId": str,
        "Arn": str,
        "CreateDate": datetime,
        "AssumeRolePolicyDocument": str,
        "InstanceProfileList": List[InstanceProfileOutputTypeDef],
        "RolePolicyList": List[PolicyDetailOutputTypeDef],
        "AttachedManagedPolicies": List[AttachedPolicyOutputTypeDef],
        "PermissionsBoundary": AttachedPermissionsBoundaryOutputTypeDef,
        "Tags": List[TagOutputTypeDef],
        "RoleLastUsed": RoleLastUsedOutputTypeDef,
    },
)

SimulatePolicyResponseOutputTypeDef = TypedDict(
    "SimulatePolicyResponseOutputTypeDef",
    {
        "EvaluationResults": List[EvaluationResultOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetAccountAuthorizationDetailsResponseOutputTypeDef = TypedDict(
    "GetAccountAuthorizationDetailsResponseOutputTypeDef",
    {
        "UserDetailList": List[UserDetailOutputTypeDef],
        "GroupDetailList": List[GroupDetailOutputTypeDef],
        "RoleDetailList": List[RoleDetailOutputTypeDef],
        "Policies": List[ManagedPolicyDetailOutputTypeDef],
        "IsTruncated": bool,
        "Marker": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)
